SystemOrganization addCategory: #'Athens-Cairo'!
SystemOrganization addCategory: #'Athens-Cairo-Paints'!
SystemOrganization addCategory: #'Athens-Cairo-Paths'!
SystemOrganization addCategory: #'Athens-Cairo-Quartz'!
SystemOrganization addCategory: #'Athens-Cairo-Text'!
SystemOrganization addCategory: #'Athens-Cairo-Transforms'!

Trait named: #TCairoLibrary
	uses: {}
	category: 'Athens-Cairo'!

!TCairoLibrary commentStamp: '<historical>' prior: 0!
a simple trait used for NB callouts to cairo library functions!

!TCairoLibrary classSide methodsFor: 'library path' stamp: 'IgorStasenko 6/10/2012 05:43'!
nbLibraryNameOrHandle
	^ CairoLibraryLoader getLibraryHandle! !

!TCairoLibrary methodsFor: 'library path' stamp: 'IgorStasenko 12/20/2011 16:52'!
nbLibraryNameOrHandle
	^ self class nbLibraryNameOrHandle
! !

NBExternalStructure variableByteSubclass: #CairoFontExtents
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Cairo-Text'!

!CairoFontExtents commentStamp: '<historical>' prior: 0!
I represent the
cairo_font_extents_t structure type

The cairo_font_extents_t structure stores metric information for a font. Values are given in the current user-space coordinate system.

Because font metrics are in user-space coordinates, they are mostly, but not entirely, independent of the current transformation matrix. If you call cairo_scale(cr, 2.0, 2.0), text will be drawn twice as big, but the reported text extents will not be doubled. They will change slightly due to hinting (so you can't assume that metrics are independent of the transformation matrix), but otherwise will remain unchanged.

double ascent;
	the distance that the font extends above the baseline. Note that this is not always exactly equal to the maximum of the extents of all the glyphs in the font, but rather is picked to express the font designer's intent as to how the font should align with elements above it.

double descent;
	the distance that the font extends below the baseline. This value is positive for typical fonts that include portions below the baseline. Note that this is not always exactly equal to the maximum of the extents of all the glyphs in the font, but rather is picked to express the font designer's intent as to how the font should align with elements below it.

double height;
	the recommended vertical distance between baselines when setting consecutive lines of text with the font. This is greater than ascent+descent by a quantity known as the line spacing or external leading. When space is at a premium, most fonts can be set with only a distance of ascent+descent between lines.

double max_x_advance;
	the maximum distance in the X direction that the origin is advanced for any glyph in the font.

double max_y_advance;
	the maximum distance in the Y direction that the origin is advanced for any glyph in the font. This will be zero for normal fonts used for horizontal writing. (The scripts of East Asia are sometimes written vertically.)!

!CairoFontExtents class methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 6/11/2012 06:56'!
fieldsDesc 

	^ #(
	double ascent;
	double descent;
	double height;
	double max_x_advance;
	double max_y_advance;
	)! !

NBExternalStructure variableByteSubclass: #CairoTextExtents
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Cairo-Text'!

!CairoTextExtents commentStamp: '<historical>' prior: 0!
I represent the
cairo_text_extents_t
structure type

The cairo_text_extents_t structure stores the extents of a single glyph or a string of glyphs in user-space coordinates. Because text extents are in user-space coordinates, they are mostly, but not entirely, independent of the current transformation matrix. If you call cairo_scale(cr, 2.0, 2.0), text will be drawn twice as big, but the reported text extents will not be doubled. They will change slightly due to hinting (so you can't assume that metrics are independent of the transformation matrix), but otherwise will remain unchanged.

double x_bearing;
	the horizontal distance from the origin to the leftmost part of the glyphs as drawn. Positive if the glyphs lie entirely to the right of the origin.

double y_bearing;
	the vertical distance from the origin to the topmost part of the glyphs as drawn. Positive only if the glyphs lie completely below the origin; will usually be negative.

double width;
	width of the glyphs as drawn

double height;
	height of the glyphs as drawn

double x_advance;
	distance to advance in the X direction after drawing these glyphs

double y_advance;
	distance to advance in the Y direction after drawing these glyphs. Will typically be zero except for vertical text layout as found in East-Asian languages.!

!CairoTextExtents class methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 6/11/2012 07:01'!
fieldsDesc 
	^ #(
	double x_bearing;
	double y_bearing;
	double width;
	double height;
	double x_advance;
	double y_advance;
	)! !

NBExternalStructure variableByteSubclass: #SQSurfaceDispatch
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Cairo'!

!SQSurfaceDispatch commentStamp: 'IgorStasenko 12/30/2011 12:35' prior: 0!
A structure from SurfacePlugin.h 
 

typedef struct sqSurfaceDispatch {
	/* Version information. Must be provided by the client
	   so the surface manager can check if certain operations
	   are supported. */
	int majorVersion;
	int minorVersion;

	/* Version 1.0 */
	fn_getSurfaceFormat getSurfaceFormat;
	fn_lockSurface lockSurface;
	fn_unlockSurface unlockSurface;
	fn_showSurface showSurface;
} sqSurfaceDispatch; 
!

!SQSurfaceDispatch class methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/30/2011 12:30'!
fieldsDesc

"
A structure from SurfacePlugin.h 
 

typedef struct sqSurfaceDispatch {
	/* Version information. Must be provided by the client
	   so the surface manager can check if certain operations
	   are supported. */
	int majorVersion;
	int minorVersion;

	/* Version 1.0 */
	fn_getSurfaceFormat getSurfaceFormat;
	fn_lockSurface lockSurface;
	fn_unlockSurface unlockSurface;
	fn_showSurface showSurface;
} sqSurfaceDispatch; 
"
	^ #(
		int majorVersion;
		int minorVersion;
		void* getSurfaceFormatFn;
		void* lockSurfaceFn;
		void* unlockSurfaceFn;
		void* showSurfaceFn
	)! !

!SQSurfaceDispatch methodsFor: 'initialize-release' stamp: 'IgorStasenko 12/30/2011 12:35'!
initialize
	self
		majorVersion: 1; 
		minorVersion: 0! !

AthensPathBuilder subclass: #AthensCairoPathBuilder
	uses: TCairoLibrary
	instanceVariableNames: 'context absolute endPoint'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Cairo-Paths'!

!AthensCairoPathBuilder commentStamp: '<historical>' prior: 0!
i implement cairo-specific path builder. see my superclass for more details.!

AthensCairoPathBuilder class
	uses: TCairoLibrary classTrait
	instanceVariableNames: ''!

!AthensCairoPathBuilder class methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 3/7/2012 14:53'!
buildPathFrom:  aPathCreatingBlock 

	! !

!AthensCairoPathBuilder methodsFor: 'path commands' stamp: 'IgorStasenko 3/7/2012 16:45'!
absolute
	absolute := true! !

!AthensCairoPathBuilder methodsFor: 'private' stamp: 'IgorStasenko 3/8/2012 16:36'!
angleOfVector: v

	| n acos |
	
	n := v normalized.
	acos := n x arcCos.
	
	^ v y < 0 ifTrue: [ Float pi * 2 - acos ] ifFalse: [ acos ]! !

!AthensCairoPathBuilder methodsFor: 'private' stamp: 'IgorStasenko 3/8/2012 16:47'!
arcCenterX: xc centerY: yc radius: radius startAngle: angle1 endAngle: angle2 
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	self nbCall: #(void cairo_arc (AthensCairoCanvas context,
				double xc,
				double yc,
				double radius,
				double angle1,
				double angle2) )
				
			! !

!AthensCairoPathBuilder methodsFor: 'private' stamp: 'IgorStasenko 3/8/2012 17:01'!
arcNegativeCenterX: xc centerY: yc radius: radius startAngle: angle1 endAngle: angle2 
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	self nbCall: #(void cairo_arc_negative (AthensCairoCanvas context,
				double xc,
				double yc,
				double radius,
				double angle1,
				double angle2) )
				
			! !

!AthensCairoPathBuilder methodsFor: 'private' stamp: 'IgorStasenko 6/3/2013 17:09'!
arcTo: newEndPoint angle: angle cw: aBool

	" Add a clockwise arc segment, starting from current path endpoint and
	ending at andPt. Angle should be specified in radians 
	"

	| start end center v radius startAngle endAngle cwAngle |	
		
	angle isZero ifTrue: [ ^ self lineTo: newEndPoint ].
	 
	start := endPoint.
	endPoint := end := self toAbsolute: newEndPoint.

	"we have to transform the input. because Cario expects 
	the center , radius, starting and ending angle,
	and we have the starting point, the ending point , and the angle.
	"
	aBool ifTrue: [cwAngle := angle] ifFalse: [cwAngle := angle negated].
	center := self calcCenter: start end: end  angle: cwAngle.
	v := (start - center).
	radius := v r.
	startAngle := self angleOfVector: v.
	endAngle := self angleOfVector: (end-center).
	aBool ifTrue: [ self arcCenterX: center x centerY: center y  radius: radius  startAngle: startAngle endAngle: endAngle ]
		ifFalse: [ self arcNegativeCenterX: center x centerY: center y  radius: radius  startAngle: startAngle  endAngle: endAngle ]
		! !

!AthensCairoPathBuilder methodsFor: 'private' stamp: 'IgorStasenko 3/8/2012 16:54'!
calcCenter: start end: end angle: angle

	| v  rot  center radius len sina cosa m |	

	v := end - start.
	
	m := AthensAffineTransform new rotateByRadians: (Float pi - angle   /2).

	v := m transform: v.		
	len := v r.
	radius := len / 2 / (angle /2) sin.
	
	center := v * (radius/len) + start.

	^ center! !

!AthensCairoPathBuilder methodsFor: 'path commands' stamp: 'IgorStasenko 3/8/2012 17:06'!
ccwArcTo: newEndPoint angle: angle
	" Add a counter-clockwise arc segment, starting from current path endpoint and
	ending at andPt. Angle should be specified in radians 
	"
	^ self arcTo: newEndPoint angle: angle cw: false! !

!AthensCairoPathBuilder methodsFor: 'path commands' stamp: 'FernandoOlivero 3/9/2012 14:42'!
close

	self closePath.
	
	endPoint := self getCurrentPoint! !

!AthensCairoPathBuilder methodsFor: 'private' stamp: 'FernandoOlivero 3/9/2012 14:43'!
closePath
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	self nbCall: #(void cairo_close_path (AthensCairoCanvas context))! !

!AthensCairoPathBuilder methodsFor: 'accessing' stamp: 'IgorStasenko 3/7/2012 15:15'!
context: anObject

	context := anObject! !

!AthensCairoPathBuilder methodsFor: 'private' stamp: 'IgorStasenko 3/7/2012 16:47'!
copyPath 


	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	^ self nbCall: #( AthensCairoPath cairo_copy_path (AthensCairoCanvas context) )
! !

!AthensCairoPathBuilder methodsFor: 'accessing' stamp: 'IgorStasenko 3/7/2012 17:15'!
createPath: aBlock
	
	self newPath.
	"set default to relative"
	absolute := false.
	endPoint := ZeroPoint.
	
	"set the implicit path origin"
	self moveToX: 0 Y: 0.
		
	aBlock value: self.
	
	^ self copyPath initialize ! !

!AthensCairoPathBuilder methodsFor: 'path commands' stamp: 'FernandoOlivero 3/11/2012 00:52'!
curveVia: p1 and: p2 to: aPoint
	|  pt1 pt2 |

	pt1 := self toAbsolute: p1.
	pt2 := self toAbsolute: p2.
	endPoint := self toAbsolute: aPoint.

	self curveViaX: pt1 x Y: pt1 y viaX: pt2 x Y: pt2 y toX: endPoint x Y: endPoint y
! !

!AthensCairoPathBuilder methodsFor: 'path commands' stamp: 'IgorStasenko 3/7/2012 17:45'!
curveVia: p1 to: aPoint
	| pt0 pt1 cp1 cp2 twoThirds |
	"Quad bezier curve"

	pt0 := endPoint.
	pt1 := self toAbsolute: p1.
	endPoint := self toAbsolute: aPoint.

"Any quadratic spline can be expressed as a cubic (where the cubic term is zero). The end points of the cubic will be the same as the quadratic's.

	CP0 = QP0
	CP3 = QP2

The two control points for the cubic are:

	CP1 = QP0 + 2/3 *(QP1-QP0)
	CP2 = QP2 + 2/3 *(QP1-QP2)"

	twoThirds := (2/3) asFloat.

	cp1 := pt1 - pt0 * twoThirds + pt0.
	cp2 := pt1 - endPoint * twoThirds + endPoint.
	
	self curveViaX: cp1 x Y: cp1 y viaX: cp2 x Y: cp2 y toX: endPoint x Y: endPoint y
! !

!AthensCairoPathBuilder methodsFor: 'private' stamp: 'IgorStasenko 3/7/2012 17:39'!
curveViaX: x1 Y: y1 viaX: x2 Y: y2 toX: x3 Y: y3
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	^ self nbCall: #(void cairo_curve_to(AthensCairoCanvas context,
                                                         double x1,
                                                         double y1,
                                                         double x2,
                                                         double y2,
                                                         double x3,
                                                         double y3))

! !

!AthensCairoPathBuilder methodsFor: 'path commands' stamp: 'IgorStasenko 3/8/2012 17:05'!
cwArcTo: newEndPoint angle: angle
	" Add a clockwise arc segment, starting from current path endpoint and
	ending at andPt. Angle should be specified in radians 
	"
	^ self arcTo: newEndPoint angle: angle cw: true! !

!AthensCairoPathBuilder methodsFor: 'private' stamp: 'IgorStasenko 9/3/2012 02:40'!
getCurrentPoint
	^ context getCurrentPoint! !

!AthensCairoPathBuilder methodsFor: 'path commands' stamp: 'FernandoOlivero 3/29/2012 18:18'!
lineTo: aPoint

	endPoint := self toAbsolute: aPoint.
	^ self lineToX: endPoint x asFloat Y: endPoint y asFloat! !

!AthensCairoPathBuilder methodsFor: 'private' stamp: 'IgorStasenko 3/7/2012 16:08'!
lineToX: x Y: y

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	^ self nbCall: #(void cairo_line_to (AthensCairoCanvas context,
		 double x, double y ) )
! !

!AthensCairoPathBuilder methodsFor: 'path commands' stamp: 'FernandoOlivero 3/29/2012 14:16'!
moveTo: aPoint
	
	endPoint := self toAbsolute: aPoint.
	
	^ self moveToX: endPoint x asFloat Y: endPoint y asFloat ! !

!AthensCairoPathBuilder methodsFor: 'private' stamp: 'IgorStasenko 3/7/2012 16:07'!
moveToX: x Y: y
	" move command always starts a new contour "

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	^ self nbCall: #(void cairo_move_to (AthensCairoCanvas context,
		 double x, double y ) )
! !

!AthensCairoPathBuilder methodsFor: 'private' stamp: 'IgorStasenko 3/7/2012 16:04'!
newPath
 
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	^ self nbCall: #( void cairo_new_path ( AthensCairoCanvas context ) )! !

!AthensCairoPathBuilder methodsFor: 'path commands' stamp: 'IgorStasenko 3/7/2012 16:45'!
relative
	absolute := false! !

!AthensCairoPathBuilder methodsFor: 'path commands' stamp: 'IgorStasenko 3/7/2012 16:20'!
toAbsolute: aPoint

	^ absolute ifTrue: [ aPoint ] ifFalse: [ endPoint + aPoint ]! !

NBExternalObject subclass: #AthensCairoPath
	uses: TCairoLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Cairo-Paths'!

!AthensCairoPath commentStamp: '<historical>' prior: 0!
i used to hold shapes built by path builder in cairo backend!

AthensCairoPath class
	uses: TCairoLibrary classTrait
	instanceVariableNames: ''!

!AthensCairoPath class methodsFor: 'instance creation' stamp: ''!
finalizeResourceData: aHandle

	self primDestroyPath: aHandle value ! !

!AthensCairoPath class methodsFor: 'instance creation' stamp: ''!
primDestroyPath: aHandle

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	^ self nbCall: #(void cairo_path_destroy ( ulong aHandle ))
! !

!AthensCairoPath methodsFor: 'converting' stamp: 'IgorStasenko 5/6/2013 05:44'!
asAthensShapeOn: anAthensCanvas 
	
	^ self! !

!AthensCairoPath methodsFor: 'initialize-release' stamp: 'FernandoOlivero 3/28/2012 19:10'!
initialize 
	handle value = 0 ifTrue: [ 
		self error: 'Error creating new path' ].

	NBExternalResourceManager addResource: self data: handle! !

!AthensCairoPath methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 3/8/2012 17:29'!
loadInto: context

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	 
	^ self nbCall: #( void cairo_append_path (AthensCairoCanvas context, self ))
! !

!AthensCairoPath methodsFor: 'drawing' stamp: 'IgorStasenko 12/20/2011 18:33'!
paintFillsUsing: aPaint on: anAthensCanvas 
	
	"This method is a part of rendering dispatch  Canvas->receiver->paint"
	
	^ aPaint fillPath: self on: anAthensCanvas! !

!AthensCairoPath methodsFor: 'instance creation' stamp: 'FernandoOlivero 3/28/2012 19:12'!
primDestroyPath: aHandle

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	^ self nbCall: #(void cairo_path_destroy ( ulong aHandle ))
! !

NBExternalStructure variableByteSubclass: #AthensCairoMatrix
	uses: TCairoLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'AthensCairoDefs'
	category: 'Athens-Cairo-Transforms'!

!AthensCairoMatrix commentStamp: '<historical>' prior: 0!
I implement an AthensAffineTransform interface.!

AthensCairoMatrix class
	uses: TCairoLibrary classTrait
	instanceVariableNames: ''!

!AthensCairoMatrix class methodsFor: 'as yet unclassified' stamp: ''!
fieldsDesc
	^ #(
   double sx; double shx;
   double shy; double sy;
   double x; double y;	
	)! !

!AthensCairoMatrix methodsFor: 'transformations' stamp: ''!
clearTranslation
	"reset a translation from matrix, leaving only scale and rotation"
	
	self x: 0.
	self y: 0.! !

!AthensCairoMatrix methodsFor: 'private' stamp: 'IgorStasenko 6/4/2012 17:59'!
copyFromMatrix: m

	NativeBoost memCopy: m to: self size: self class instanceSize.! !

!AthensCairoMatrix methodsFor: 'accessing' stamp: 'IgorStasenko 8/31/2012 22:31'!
getMatrix
	
	"Shall we answer an AthensAffineMatrix instead?
	
	^ AthensAffineMatrix new loadAffineTransform: self
	 "

	^ self copy! !

!AthensCairoMatrix methodsFor: 'initialize-release' stamp: ''!
initialize
	self loadIdentity.! !

!AthensCairoMatrix methodsFor: 'private' stamp: 'IgorStasenko 5/31/2012 01:41'!
initx: x y: y sx: sx sy: sy shx: shx shy: shy

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	^self nbCall: #(
		void cairo_matrix_init (AthensCairoMatrix * self,
			double sx,
			double shx,
			double shy,
			double sy,
			double x,
			double y))

! !

!AthensCairoMatrix methodsFor: 'transformations' stamp: ''!
inverseTransform: aPoint 

	^ self inverted transform: aPoint! !

!AthensCairoMatrix methodsFor: 'transformations' stamp: 'IgorStasenko 5/31/2012 01:41'!
invert

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	^self nbCall: #( cairo_status_t cairo_matrix_invert (AthensCairoMatrix *  self))

! !

!AthensCairoMatrix methodsFor: 'transformations' stamp: 'FernandoOlivero 4/21/2012 02:35'!
inverted
 	| m |
	m := self copy.
	m invert.
	^ m! !

!AthensCairoMatrix methodsFor: 'transformations' stamp: ''!
loadAffineTransform: m
	self initx: m x y: m y sx: m sx sy: m sy shx: m shx shy: m shy! !

!AthensCairoMatrix methodsFor: 'transformations' stamp: ''!
loadIdentity
	"initialize with identity transform"
	
	self primLoadIdentity ! !

!AthensCairoMatrix methodsFor: 'transformations' stamp: 'IgorStasenko 3/28/2012 16:32'!
multiplyBy: anAthensAffineTransform
	
	self primMultiplyBy: (
		self class new loadAffineTransform: anAthensAffineTransform)! !

!AthensCairoMatrix methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 5/31/2012 01:42'!
primLoadIdentity
	"initialize with identity transform"
	
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>

	^ self nbCall: #( void cairo_matrix_init_identity (AthensCairoMatrix * self ) )! !

!AthensCairoMatrix methodsFor: 'transformations' stamp: 'IgorStasenko 5/31/2012 01:57'!
primMultiplyBy: m
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>

	^self nbCall: #(void   cairo_matrix_multiply
		(AthensCairoMatrix * self,
		AthensCairoMatrix * m ,
		AthensCairoMatrix * self ) )

! !

!AthensCairoMatrix methodsFor: 'private' stamp: 'IgorStasenko 5/31/2012 01:42'!
primTransformX: x Y: y

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	^self nbCall: #( void cairo_matrix_transform_point (AthensCairoMatrix *  self, double * x, double * y))

! !

!AthensCairoMatrix methodsFor: 'transformations' stamp: 'IgorStasenko 6/3/2012 04:07'!
restoreAfter: aBlock
	|previous|
	previous := self copy.
	aBlock ensure: [ 
		self copyFromMatrix: previous. "just copy the memory"
		"self loadAffineTransform: previous" ]! !

!AthensCairoMatrix methodsFor: 'transformations' stamp: ''!
rotateByDegrees: angle


	^ self rotateByRadians: angle degreesToRadians! !

!AthensCairoMatrix methodsFor: 'transformations' stamp: 'IgorStasenko 5/31/2012 01:43'!
rotateByRadians: angle

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	^self nbCall: #(
		void cairo_matrix_rotate (AthensCairoMatrix *  self,
                                                         double angle))

! !

!AthensCairoMatrix methodsFor: 'transformations' stamp: 'FernandoOlivero 3/22/2012 13:35'!
scaleBy: factor

	"if factor is number, do a uniform scale, 
	if not, then factor is assument to be an instance of Point containing non-uniform scale for each axis"
	factor isPoint 
		ifTrue: [ self scaleX: factor x asFloat Y: factor y asFloat ] 
		ifFalse: [ self scaleX: factor asFloat Y: factor asFloat ]
! !

!AthensCairoMatrix methodsFor: 'transformations' stamp: 'IgorStasenko 5/31/2012 01:43'!
scaleX: fx Y: fy

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	^self nbCall: #(
		void cairo_matrix_scale (AthensCairoMatrix * self,
                                                         double fx,
                                                         double fy))

! !

!AthensCairoMatrix methodsFor: 'transformations' stamp: 'IgorStasenko 5/31/2012 01:43'!
setRotationInRadians: radians

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	^self nbCall: #( void cairo_matrix_init_rotate (AthensCairoMatrix * self, double  radians))

! !

!AthensCairoMatrix methodsFor: 'transformations' stamp: 'IgorStasenko 5/31/2012 01:43'!
setScaleX: x Y: y

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	^self nbCall: #( void cairo_matrix_init_scale (AthensCairoMatrix * self, double  x, double  y))

! !

!AthensCairoMatrix methodsFor: 'transformations' stamp: 'IgorStasenko 5/31/2012 01:43'!
setTranslateX: x Y: y

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	^self nbCall: #( void cairo_matrix_init_translate (AthensCairoMatrix * self, double  x, double  y))

! !

!AthensCairoMatrix methodsFor: 'transformations' stamp: ''!
transform: aPoint
	| x y |
	"since we use pointers to floats we must create a copy of original values to not scratch them"
	x := aPoint x asFloat shallowCopy.
	y := aPoint y asFloat shallowCopy.
	
	self primTransformX: x Y: y.
	^ x @ y! !

!AthensCairoMatrix methodsFor: 'transformations' stamp: ''!
translateBy: aPoint
	self translateX: aPoint x Y: aPoint y
! !

!AthensCairoMatrix methodsFor: 'transformations' stamp: 'IgorStasenko 5/31/2012 01:44'!
translateX: px Y: py

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	^self nbCall: #(
		void cairo_matrix_translate (AthensCairoMatrix * self,
                                                         double px,
                                                         double py))

! !

NBExternalObject subclass: #AthensCairoPatternPaint
	uses: TCairoLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'AthensCairoDefs'
	category: 'Athens-Cairo-Paints'!

!AthensCairoPatternPaint commentStamp: '<historical>' prior: 0!
i am abstract class for different kinds of paints in cairo backend.!

AthensCairoPatternPaint class
	uses: TCairoLibrary classTrait
	instanceVariableNames: ''!

AthensCairoPatternPaint subclass: #AthensCairoGradientPaint
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'AthensCairoDefs'
	category: 'Athens-Cairo-Paints'!

!AthensCairoGradientPaint commentStamp: '<historical>' prior: 0!
i used to represent gradient paints (both radial and linear)  in cairo backend!

!AthensCairoGradientPaint class methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 4/12/2013 10:25'!
createLinearGradient: aColorRamp start: aStartPoint stop: aStopPoint
	| paint |
	paint := self
		primCreateLinearX0: aStartPoint x asFloat
		y0: aStartPoint y asFloat
		x1: aStopPoint x asFloat
		y1: aStopPoint y asFloat.
	
	"note, we do #initialize here because instance was created by primitive"
	paint initialize; populateRamp: aColorRamp.
	^ paint
! !

!AthensCairoGradientPaint class methodsFor: 'primitives' stamp: 'IgorStasenko 4/12/2013 10:23'!
primCreateLinearX0: x0 y0: y0 x1: x1 y1: y1
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #(AthensCairoGradientPaint cairo_pattern_create_linear (
		double x0,
		double y0,
		double x1,
		double y1 ) )
! !

!AthensCairoGradientPaint class methodsFor: 'primitives' stamp: 'FernandoOlivero 4/19/2012 13:55'!
primCreateRadialXo: xo yo: yo radiuso: radiuso x1: x1 y1: y1 radius1: radius1
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #(AthensCairoGradientPaint cairo_pattern_create_radial (
		double xo,
		double yo,
		double radiuso,
		double x1,
		double y1,
		double radius1 ) )
! !

!AthensCairoGradientPaint class methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 4/19/2012 13:56'!
radialBetween: origin
	extending: innerRadius
	and: outerOrigin
	extending: outerRadius
	withColorRamp: colorRamp
	| paint |

	paint := self
		primCreateRadialXo: origin x 
		yo: origin y 
		radiuso: innerRadius 
		x1: outerOrigin x
		y1: outerOrigin y 
		radius1: outerRadius.
	paint
		initializeRadialBetween: origin
			extending: innerRadius
			and: outerOrigin
			extending: outerRadius
			withColorRamp: colorRamp.
	^ paint.! !

!AthensCairoGradientPaint methodsFor: 'private' stamp: 'IgorStasenko 4/12/2013 10:19'!
addColorStopAt: anOffset colored: aColor

	self
		primAddColorStopOffset: anOffset R: aColor red G: aColor green B: aColor blue A: aColor alpha
		! !

!AthensCairoGradientPaint methodsFor: 'initialize-release' stamp: 'FernandoOlivero 4/19/2012 14:13'!
defaultExtend
"The default extend mode is CAIRO_EXTEND_NONE for surface patterns and CAIRO_EXTEND_PAD for gradient patterns.
"
	^  CAIRO_EXTEND_PAD! !

!AthensCairoGradientPaint methodsFor: 'initialize-release' stamp: 'FernandoOlivero 4/19/2012 13:56'!
initializeRadialBetween: origin
			extending: innerRadius
			and: outerOrigin
			extending: outerRadius
			withColorRamp: aRamp
			
	self initialize.		
	aRamp do:[:each|
		self
			addColorStopAt: each key
			colored: each value ]
	! !

!AthensCairoGradientPaint methodsFor: 'private' stamp: 'IgorStasenko 4/12/2013 10:17'!
populateRamp: aRamp
	aRamp do: [ :each |
		self
			addColorStopAt: each key
			colored: each value ]
	! !

!AthensCairoGradientPaint methodsFor: 'primitives' stamp: 'IgorStasenko 4/12/2013 10:21'!
primAddColorStopOffset: offset R: red G: green B: blue A: alpha 
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall:#( void cairo_pattern_add_color_stop_rgba ( cairo_pattern_t  self,
					double offset,
					double red,
					double green,
					double blue,
					double alpha ))
		! !

!AthensCairoPatternPaint class methodsFor: 'private' stamp: ''!
finalizeResourceData: handle

	self primDestroyPattern: handle value ! !

!AthensCairoPatternPaint class methodsFor: 'private' stamp: ''!
primDestroyPattern: aHandle
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	self nbCall: #(void cairo_pattern_destroy (ulong aHandle) )
 ! !

!AthensCairoPatternPaint methodsFor: 'converting' stamp: ''!
asAthensPaintOn: anAthensCanvas	
	^ self! !

!AthensCairoPatternPaint methodsFor: 'converting' stamp: 'IgorStasenko 4/27/2012 11:30'!
asStrokePaintOn: aCanvas
	^ aCanvas surface createStrokePaintFor: self! !

!AthensCairoPatternPaint methodsFor: 'initialize-release' stamp: 'FernandoOlivero 4/19/2012 14:14'!
defaultExtend
"The default extend mode is CAIRO_EXTEND_NONE for surface patterns and CAIRO_EXTEND_PAD for gradient patterns.
"
	
	^  CAIRO_EXTEND_NONE! !

!AthensCairoPatternPaint methodsFor: 'drawing' stamp: ''!
fillOn: aCanvas
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #(void cairo_fill (AthensCairoCanvas aCanvas ))
! !

!AthensCairoPatternPaint methodsFor: 'drawing' stamp: 'BenjaminVanRyseghem 7/3/2013 13:47'!
fillPath: path on: anAthensCanvas 

	anAthensCanvas
		newPath;
		loadPath: path.
	self setMatrix: anAthensCanvas paintTransform inverted.
	self loadOn: anAthensCanvas.
	self fillOn: anAthensCanvas! !

!AthensCairoPatternPaint methodsFor: 'drawing' stamp: 'IgorStasenko 7/3/2013 15:38'!
fillRectangle: aRect on: anAthensCanvas
	"This is a terminal method in rendering dispatch scheme
	canvas->shape->paint. See AthensCanvas>>fillShape: "

	anAthensCanvas
		rectangleX: aRect left
		y: aRect top
		width: aRect width
		height: aRect height.
	
	self setMatrix: anAthensCanvas paintTransform inverted.
	self loadOn: anAthensCanvas .
	self fillOn: anAthensCanvas.	
! !

!AthensCairoPatternPaint methodsFor: 'initialize-release' stamp: ''!
initialize
	
	handle value = 0 ifTrue: [ 
		self error: 'Error creating new paint' ].
	
	"register to be finalized"
	NBExternalResourceManager addResource: self data: handle.! !

!AthensCairoPatternPaint methodsFor: 'testing' stamp: 'IgorStasenko 3/28/2012 18:50'!
isPatternTypeMismatch
	^ self status = CAIRO_STATUS_PATTERN_TYPE_MISMATCH.! !

!AthensCairoPatternPaint methodsFor: 'testing' stamp: ''!
isSuccess
	^ self status  =	CAIRO_STATUS_SUCCESS! !

!AthensCairoPatternPaint methodsFor: 'drawing' stamp: 'IgorStasenko 7/3/2013 14:35'!
loadOn: anAthensCanvas 
	"
	Note: The pattern's transformation matrix will be locked to the user space in effect at the time of cairo_set_source(). This means that further modifications of the current transformation matrix will not affect the source pattern. See cairo_pattern_set_matrix().
	"

	self isSuccess
		ifTrue:[ self primSetSourceOn: anAthensCanvas.]
		ifFalse:[ anAthensCanvas setSourceR: 1.0 g: 0.0 b: 0.0 a: 1.0].
	 
		
! !

!AthensCairoPatternPaint methodsFor: 'drawing' stamp: 'FernandoOlivero 4/19/2012 15:01'!
maskOn: anAthensCanvas
"
A drawing operator that paints the current source using the alpha channel of pattern as a mask. (Opaque areas of pattern are painted with the source, transparent areas are not painted.)
"
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #(void cairo_mask(cairo_t anAthensCanvas, self))! !

!AthensCairoPatternPaint methodsFor: 'accessing' stamp: 'IgorStasenko 8/31/2012 01:12'!
noRepeat
	self primSetExtend: CAIRO_EXTEND_NONE.
! !

!AthensCairoPatternPaint methodsFor: 'primitives' stamp: 'IgorStasenko 3/30/2012 18:13'!
primSetExtend: extend

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	^ self nbCall:#(
		void cairo_pattern_set_extend ( self , ulong extend) )
		! !

!AthensCairoPatternPaint methodsFor: 'primitives' stamp: 'FernandoOlivero 4/19/2012 14:00'!
primSetSourceOn: aCanvas
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #(void cairo_set_source ( cairo_t  aCanvas,  self))
		! !

!AthensCairoPatternPaint methodsFor: 'accessing' stamp: 'IgorStasenko 8/31/2012 01:13'!
reflect
	self primSetExtend: CAIRO_EXTEND_REFLECT.! !

!AthensCairoPatternPaint methodsFor: 'accessing' stamp: 'IgorStasenko 8/31/2012 01:14'!
repeat
	self primSetExtend: CAIRO_EXTEND_REPEAT.! !

!AthensCairoPatternPaint methodsFor: 'accessing' stamp: 'IgorStasenko 4/12/2013 10:29'!
setExtend: aSymbol
	"
	typedef enum {
    CAIRO_EXTEND_NONE,
    CAIRO_EXTEND_REPEAT,
    CAIRO_EXTEND_REFLECT,
    CAIRO_EXTEND_PAD
} cairo_extend_t;
	"
	| enum |
	enum := self defaultExtend.
	aSymbol = #None ifTrue: [ enum := CAIRO_EXTEND_NONE ].
	aSymbol = #Repeat ifTrue: [ enum := CAIRO_EXTEND_REPEAT ].
	aSymbol = #Reflect ifTrue: [ enum := CAIRO_EXTEND_REFLECT ].
	aSymbol = #Pad ifTrue: [ enum := CAIRO_EXTEND_PAD ].
	self primSetExtend: enum.! !

!AthensCairoPatternPaint methodsFor: 'accessing' stamp: 'IgorStasenko 5/31/2012 01:53'!
setMatrix: m

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	self nbCall: #( 
		void
			cairo_pattern_set_matrix ( self, AthensCairoMatrix * m)
		)
! !

!AthensCairoPatternPaint methodsFor: 'accessing' stamp: 'FernandoOlivero 1/13/2012 20:15'!
status
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #(int cairo_pattern_status (cairo_pattern_t  self))
		! !

AthensCairoPatternPaint subclass: #AthensCairoPatternSurfacePaint
	instanceVariableNames: 'surface origin direction'
	classVariableNames: ''
	poolDictionaries: 'AthensCairoDefs'
	category: 'Athens-Cairo-Paints'!

!AthensCairoPatternSurfacePaint commentStamp: '<historical>' prior: 0!
i represent texture/image/form/surface paints in cairo backend.!

!AthensCairoPatternSurfacePaint class methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 4/19/2012 13:57'!
createForSurface: anAthensCairoSurface
	|pat|
	pat := self primCreateForSurface: anAthensCairoSurface .
	pat initializeFor: anAthensCairoSurface  .
	^ pat! !

!AthensCairoPatternSurfacePaint class methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 4/19/2012 13:57'!
primCreateForSurface: anAthensCairoSurface
	
"	pattern = cairo_pattern_create_for_surface (image);"
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #(AthensCairoPatternSurfacePaint cairo_pattern_create_for_surface(
		cairo_surface_t  anAthensCairoSurface ) )
! !

!AthensCairoPatternSurfacePaint methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 10/11/2012 17:29'!
direction: aPoint 
	direction := aPoint.! !

!AthensCairoPatternSurfacePaint methodsFor: 'accessing' stamp: 'FernandoOlivero 4/22/2012 23:39'!
extent
	^ surface extent ! !

!AthensCairoPatternSurfacePaint methodsFor: 'initialize-release' stamp: 'FernandoOlivero 4/19/2012 13:58'!
initializeFor: anAthensCairoSurface 
	self initialize.
	surface := anAthensCairoSurface .
	! !

!AthensCairoPatternSurfacePaint methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 10/11/2012 17:15'!
origin: aPoint 
	origin := aPoint.! !

!AthensCairoPatternSurfacePaint methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 7/3/2013 16:17'!
setMatrix: aMatrix

	aMatrix restoreAfter: [
		origin ifNotNil: [ aMatrix translateBy: origin negated ].
		super setMatrix: aMatrix.
	]! !

AthensCairoPatternPaint subclass: #AthensCairoPatternSurfacePaint
	instanceVariableNames: 'surface origin direction'
	classVariableNames: ''
	poolDictionaries: 'AthensCairoDefs'
	category: 'Athens-Cairo-Paints'!

!AthensCairoPatternSurfacePaint commentStamp: '<historical>' prior: 0!
i represent texture/image/form/surface paints in cairo backend.!

AthensSurface subclass: #AthensCairoSurface
	uses: TCairoLibrary
	instanceVariableNames: 'handle context builder id ftFontRenderer session'
	classVariableNames: ''
	poolDictionaries: 'AthensCairoDefs'
	category: 'Athens-Cairo'!

AthensCairoSurface class
	uses: TCairoLibrary classTrait
	instanceVariableNames: 'uniqueSession dispatch dispatchStruct'!

!AthensCairoSurface commentStamp: '<historical>' prior: 0!
i am a concrete implementation of Athens surface which using cairo graphics library for rendering.

Cairo library, by itself can have multiple surface types.
This class uses image surface (a bitmap located in system memory) and maps to cairo_image_surface_t* C type.!

AthensCairoSurface class
	uses: TCairoLibrary classTrait
	instanceVariableNames: 'uniqueSession dispatch dispatchStruct'!

AthensCairoSurface subclass: #AthensCairoPDFSurface
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Cairo'!

!AthensCairoPDFSurface commentStamp: '<historical>' prior: 0!
i am a concrete implementation of Athens surface which using cairo graphics library for rendering for generating PDF files
as output.

<currently it is not functional and need more testing and coding>!

!AthensCairoPDFSurface class methodsFor: 'private' stamp: 'IgorStasenko 5/4/2012 18:12'!
createPDF: fileName width: width_in_points height: height_in_points

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #(AthensCairoPDFSurface cairo_pdf_surface_create (String fileName,
                                                      double width_in_points,
                                                      double height_in_points) )
! !

!AthensCairoPDFSurface class methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 5/4/2012 18:13'!
extent: anExtent fileName: fileName

	^ (self createPDF: fileName width: anExtent x height: anExtent y) initialize! !

!AthensCairoPDFSurface class methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 5/4/2012 18:34'!
finalizeResourceData: handle

	self destroySurfaceHandle: handle.
! !

!AthensCairoPDFSurface class methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 5/4/2012 18:14'!
registerSurface: surface
	"do not register my instances with SurfacePlugin"! !

!AthensCairoPDFSurface methodsFor: 'private' stamp: 'IgorStasenko 5/4/2012 18:22'!
newCanvas

	^ self primCreateCanvas surface: self! !

!AthensCairoPDFSurface methodsFor: 'initialize-release' stamp: 'IgorStasenko 5/4/2012 18:15'!
resourceData
	^ handle value ! !

!AthensCairoPDFSurface methodsFor: 'private' stamp: 'IgorStasenko 5/4/2012 18:29'!
showPage

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #( void cairo_surface_show_page (self) )! !

!AthensCairoSurface class methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/20/2011 14:49'!
asNBExternalType: gen
	"use handle ivar to hold my instance (cairo_surface_t)"
	^ NBExternalObjectType objectClass: self! !

!AthensCairoSurface class methodsFor: 'session management' stamp: ''!
checkSession
	uniqueSession == NativeBoost uniqueSessionObject ifFalse: [
		self initializeForNewSession
	].! !

!AthensCairoSurface class methodsFor: 'instance creation' stamp: 'IgorStasenko 4/12/2013 09:05'!
createFromFile: aFileName ifFailed: aBlock
	"Right now, this protocol is Cairo backend only. "
	
 	| surface cstring |
	cstring := aFileName , (Character value: 0) asString.
	surface :=  self primCreateFromFile: cstring.
	surface isSuccess not
		ifTrue: [ 
			self destroySurfaceHandle: surface handle value.
			^ aBlock cull: surface status ]
		ifFalse: [ surface initialize ].
	^ surface .! !

!AthensCairoSurface class methodsFor: 'surface plugin callbacks' stamp: ''!
createGetSurfaceFormatFn

	"
		int getSurfaceFormat(int handle, int* width, int* height, int* depth, int* isMSB);

		Return general information about the OS drawing surface.
		Return true if successful, false otherwise.

		The returned values describe the basic properties such as
		width, height, depth and LSB vs. MSB pixels.
	"

	| fn |

	fn := NBNativeFunctionGen 
		cdecl: #( int (int handle, int* width, int* height, int* depth, int* isMSB) )
		emit: [:gen :proxy :asm | | callInfo fnPtr |

			" the handle is a handle to cairo image surface (cairo_surface_t *) "

			"*width = cairo_image_surface_get_width ( handle )"
			asm cdeclCall: [:call |
				call push: (gen arg: #handle).
				asm
					mov: (self fnPtr: 'cairo_image_surface_get_width') asUImm32 to: asm EAX;
					call: asm EAX
			] alignment: gen stackAlignment;
			
			mov: (gen arg: #width) to: asm EDX;
			mov: asm EAX to: asm EDX ptr.
		
			"*height = cairo_image_surface_get_height ( handle )"
			asm cdeclCall: [:call |
				call push: (gen arg: #handle).
				asm
					mov: (self fnPtr: 'cairo_image_surface_get_height') asUImm32 to: asm EAX;
					call: asm EAX
			] alignment: gen stackAlignment;

			mov: (gen arg: #height) to: asm EDX;
			
"work around the bitblt bug which tries to access past the buffer size designated by width*height*depth "			
			dec: asm EAX;
			mov: asm EAX to: asm EDX ptr.

			"*depth = 32"
			asm 
				mov: (gen arg: #depth) to: asm EAX;
				mov: 32 to: asm EAX ptr.
			
			" *isMSB = false "
			asm 
				mov: (gen arg: #isMSB) to: asm EAX;
				mov: 0 to: asm EAX ptr;

			"return true"
				mov: 1 to: asm EAX
						
		].
	fn install.
	^ fn address! !

!AthensCairoSurface class methodsFor: 'surface plugin callbacks' stamp: ''!
createLockSurfaceFn

	"
	int lockSurface(int handle, int *pitch, int x, int y, int w, int h);
		Lock the bits of the surface.
		Return a pointer to the actual surface bits, or NULL on failure.
		If successful, store the pitch of the surface (e.g., the bytes
		per scan line).

		For equal source/dest handles only one locking operation is performed.
		This is to prevent locking of overlapping areas which does not work with
		certain APIs (e.g., DirectDraw prevents locking of overlapping areas). 
		A special case for non-overlapping but equal source/dest handle would 
		be possible but we would have to transfer this information over to 
		unlockSurfaces somehow (currently, only one unlock operation is 
		performed for equal source and dest handles). Also, this would require
		a change in the notion of ioLockSurface() which is right now interpreted
		as a hint and not as a requirement to lock only the specific portion of
		the surface.

		The arguments in ioLockSurface() provide the implementation with
		an explicit hint what area is affected. It can be very useful to
		know the max. affected area beforehand if getting the bits requires expensive
		copy operations (e.g., like a roundtrip to the X server or a glReadPixel op).
		However, the returned pointer *MUST* point to the virtual origin of the surface
		and not to the beginning of the rectangle. The promise made by BitBlt
		is to never access data outside the given rectangle (aligned to 4byte boundaries!!)
		so it is okay to return a pointer to the virtual origin that is actually outside
		the valid memory area.

		The area provided in ioLockSurface() is already clipped (e.g., it will always
		be inside the source and dest boundingBox) but it is not aligned to word boundaries
		yet. It is up to the support code to compute accurate alignment if necessary.
	"

	| fn |

	fn := NBNativeFunctionGen 
		cdecl: #(int (int handle, int *pitch, int x, int y, int w, int h) )
		emit: [:gen :proxy :asm | | callInfo fnPtr |

			" the handle is a handle to cairo image surface (cairo_surface_t *) "

			"*pitch = cairo_image_surface_get_stride ( handle )"
			asm cdeclCall: [:call |
				call push: (gen arg: #handle).
				asm
					mov: (self fnPtr: 'cairo_image_surface_get_stride') asUImm32 to: asm EAX;
					call: asm EAX
			] alignment: gen stackAlignment;
			
			mov: (gen arg: #pitch) to: asm EDX;
			mov: asm EAX to: asm EDX ptr.
		
			" return cairo_image_surface_get_data ()"
			asm cdeclCall: [:call |
				call push: (gen arg: #handle).
				asm
					mov: (self fnPtr: 'cairo_image_surface_get_data') asUImm32 to: asm EAX;
					call: asm EAX
			] alignment: gen stackAlignment
		].
	
	fn install.
	^ fn address! !

!AthensCairoSurface class methodsFor: 'surface plugin callbacks' stamp: ''!
createShowSurfaceFn

	"
	int showSurface(int handle, int x, int y, int w, int h);
		Display the contents of the surface on the actual screen.

		If ioShowSurface() is called the surface in question represents
		a Squeak DisplayScreen.

	"

	| fn |

	fn := NBNativeFunctionGen 
		cdecl: #(int (int handle, int x, int y, int w, int h))
		emit: [:gen :proxy :asm | 
			"do nothing"
			asm mov: 1 to: asm EAX
		].
	
	fn install.
	^ fn address! !

!AthensCairoSurface class methodsFor: 'surface plugin callbacks' stamp: ''!
createUnlockSurfaceFn

	"
		int unlockSurface(int handle, int x, int y, int w, int h);
		Unlock the bits of a (possibly modified) surface after BitBlt completed.
		The return value is ignored.

		The arguments provided specify the dirty region of the surface. If the
		surface is unmodified all arguments are set to zero.

	"

	| fn |

	fn := NBNativeFunctionGen 
		cdecl: #(int (int handle, int x, int y, int w, int h) )
		emit: [:gen :proxy :asm | 
			"do nothing"
		].
	
	fn install.
	^ fn address! !

!AthensCairoSurface class methodsFor: 'private' stamp: 'IgorStasenko 5/31/2012 01:50'!
destroyContextHandle: aHandle

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	^self nbCall: #( 	void cairo_destroy (size_t aHandle) )! !

!AthensCairoSurface class methodsFor: 'private' stamp: ''!
destroySurfaceHandle: handle
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	^self nbCall: #( void cairo_surface_destroy ( ulong handle ) )

! !

!AthensCairoSurface class methodsFor: 'surface plugin callbacks' stamp: ''!
dispatchStruct
	self checkSession.
	^ dispatchStruct! !

!AthensCairoSurface class methodsFor: 'instance creation' stamp: 'IgorStasenko 3/7/2012 15:32'!
extent: anExtent
	^ self extent: anExtent format: CAIRO_FORMAT_ARGB32 ! !

!AthensCairoSurface class methodsFor: 'instance creation' stamp: 'IgorStasenko 3/7/2012 15:32'!
extent: anExtent format: aFormat
	^ ( self primImage: aFormat width: anExtent x height: anExtent y ) initialize
! !

!AthensCairoSurface class methodsFor: 'finalize resources' stamp: 'IgorStasenko 5/31/2012 01:49'!
finalizeResourceData: data
	| handle id contextHandle |
	handle := data first.
	id := data second.
	contextHandle := data third.
	
	(self findSurface: id) = handle ifFalse: [ 
		self error: 'surface is not registered with surface plugin'.
		].
	
	self unregisterSurfaceWithId: id.
	self destroyContextHandle: contextHandle. 
	self destroySurfaceHandle: handle.
! !

!AthensCairoSurface class methodsFor: 'private' stamp: ''!
findSurface: surfaceId
	| buf |
	buf := ByteArray new: 4.  "sizeof(int)"
	
	
	(self ioFindSurface: surfaceId handle: buf) ifTrue: [
		^ buf nbUlongAt: 1
		].
	
	^ nil. ! !

!AthensCairoSurface class methodsFor: 'surface plugin callbacks' stamp: ''!
fnPtr: anFnName

	^ NativeBoost loadSymbol: anFnName fromModule: self nbLibraryNameOrHandle.

! !

!AthensCairoSurface class methodsFor: 'instance creation' stamp: 'IgorStasenko 10/11/2012 18:41'!
fromForm: aForm
	| form surface newBits |
	
	form := aForm unhibernate; asFormOfDepth: 32.
	surface := self extent: aForm extent.
	
	"we should convert form bits with premultiplied alpha"
	
	newBits := form bits collect:[:pixel |
		| alpha r g b|
		alpha := (pixel >> 24) / 255.
		
		r := ( (pixel bitAnd: 255) * alpha ) asInteger.
		g := ( (pixel >>8 bitAnd: 255) * alpha ) asInteger.
		b := ( (pixel >>16 bitAnd: 255) * alpha ) asInteger.
		
		(pixel bitAnd: 16rFF000000) + (b<<16) + (g<<8) + r
		].
	
	NativeBoost memCopy: newBits to: surface getDataPtr size: (form width * form height *4).
	
	surface markDirty.

	^ surface.! !

!AthensCairoSurface class methodsFor: 'session management' stamp: ''!
initializeForNewSession
	| ptr |
	uniqueSession := NativeBoost uniqueSessionObject.
	
	"create a dispatch structure"
	dispatchStruct := dispatch := SQSurfaceDispatch new.
	
	dispatch 
		getSurfaceFormatFn: self createGetSurfaceFormatFn;
		lockSurfaceFn: self createLockSurfaceFn;
		unlockSurfaceFn: self createUnlockSurfaceFn;
		showSurfaceFn: self createShowSurfaceFn.
		
	"now we should place this structure to external memory"
	
	ptr := NativeBoost allocate: (SQSurfaceDispatch instanceSize).
	NativeBoost memCopy: dispatch to: ptr size: (SQSurfaceDispatch instanceSize).
	
	dispatch := ptr.! !

!AthensCairoSurface class methodsFor: 'private' stamp: ''!
ioFindSurface: id dispatch: dispPtr handle: handlePtr
"	int ioFindSurface(int surfaceID, sqSurfaceDispatch *fn, int *surfaceHandle);
		Find the surface with the given ID, and, optionally,
		the given set of surface functions. The registered handle
		is returned in surfaceHandle. Return true if successful
		(e.g., the surface has been found), false otherwise.
"


	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	self nbCall: #( bool ioFindSurface(int id, void * dispPtr, int *handlePtr) ) module: #SurfacePlugin! !

!AthensCairoSurface class methodsFor: 'private' stamp: ''!
ioFindSurface: id handle: handlePtr
"	int ioFindSurface(int surfaceID, sqSurfaceDispatch *fn, int *surfaceHandle);
		Find the surface with the given ID, and, optionally,
		the given set of surface functions. The registered handle
		is returned in surfaceHandle. Return true if successful
		(e.g., the surface has been found), false otherwise.
"


	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	self nbCall: #( bool ioFindSurface(int id, 0 , int *handlePtr) ) module: #SurfacePlugin! !

!AthensCairoSurface class methodsFor: 'private' stamp: ''!
ioRegisterSurface: aCairoSurfaceHandle dispatch: sqSurfaceDispatchPtr surfaceId: idHolder
"
	int ioRegisterSurface(int surfaceHandle, sqSurfaceDispatch *fn, int *surfaceID);

	Register a new surface with the given handle and
	the set of surface functions. The new ID is returned
	in surfaceID. Returns true if successful, false 
	otherwise.

"

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	self nbCall: #( bool ioRegisterSurface(ulong aCairoSurfaceHandle, void * sqSurfaceDispatchPtr, int *idHolder) ) module: #SurfacePlugin! !

!AthensCairoSurface class methodsFor: 'private' stamp: ''!
ioUnregisterSurface: aCairoSurfaceId
"
	ioUnregisterSurface:
	Unregister the surface with the given id.
	Returns true if successful, false otherwise. 

"

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	self nbCall: #( int ioUnregisterSurface(ulong aCairoSurfaceId) ) module: #SurfacePlugin! !

!AthensCairoSurface class methodsFor: 'private' stamp: 'FernandoOlivero 3/29/2012 12:04'!
primCreateFromFile: aFileName

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin> 
	
	^self nbCall: #(AthensCairoSurface cairo_image_surface_create_from_png (char* aFileName)) 
! !

!AthensCairoSurface class methodsFor: 'private' stamp: 'FernandoOlivero 1/12/2012 13:02'!
primImage: aFormat width: aWidth height: aHeight
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #(AthensCairoSurface cairo_image_surface_create (int aFormat,
                                                         int aWidth,
                                                         int aHeight) )

! !

!AthensCairoSurface class methodsFor: 'private' stamp: 'IgorStasenko 12/20/2011 15:01'!
primWidth: aWidth height: aHeight
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #( AthensCairoSurface cairo_image_surface_create (
						CAIRO_FORMAT_ARGB32,
						int aWidth,
						int aHeight) )! !

!AthensCairoSurface class methodsFor: 'private' stamp: 'IgorStasenko 10/12/2012 03:37'!
registerSurface: anAthensCairoSurface
	"register the cairo surface with surface plugin,
	so, it can be used directly by bitblt operations.
	
	Answer an id and unique session object
	 "
	| id |
	self checkSession.
	
	id := ByteArray new: 8 "we need 4, but put some more (NBExternalType sizeOf: #int)".

	(self ioRegisterSurface: anAthensCairoSurface handle value dispatch: dispatch surfaceId: id)
		ifFalse: [ self error: 'Unable to register surface with SurfacePlugin'].
	
	id := id nbLongAt: 1.
	
	^ id! !

!AthensCairoSurface class methodsFor: 'private' stamp: ''!
testGetSurfaceFormat: handle width: wBuf height: hBuf depth: depthBuf isMSB: isMSBBuf

<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	NBFFICallout cdecl:  #( int (ulong handle, int* wBuf, int* hBuf, int* depthBuf, int* isMSBBuf) ) emitCall: [:gen :proxy :asm | 
		asm
			mov: (self dispatchStruct getSurfaceFormatFn) asUImm32 to: asm EAX;
			call: asm EAX
		]

! !

!AthensCairoSurface class methodsFor: 'private' stamp: ''!
testLockSurface: handle pitch: pBuf x: x y: y w: w h: h

<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	NBFFICallout cdecl:  #( 	void *  (int handle, int *pBuf, int x, int y, int w, int h) ) emitCall: [:gen :proxy :asm | 
		asm
			mov: (self dispatchStruct lockSurfaceFn) asUImm32 to: asm EAX;
			call: asm EAX
		]

! !

!AthensCairoSurface class methodsFor: 'private' stamp: ''!
testSurfacePluginCallbacks

	| surface wb hb db mb ptr |
	
	surface := AthensCairoSurface extent: 800@800.
	
	wb := ByteArray new: 4.
	hb := ByteArray new: 4.
	db := ByteArray new: 4.
	mb := ByteArray new: 4.
	
	self testGetSurfaceFormat: surface handle width: wb height: hb depth: db isMSB: mb.

	self assert: (surface width = (wb nbUlongAt: 1)).
	self assert: (surface height = (hb nbUlongAt: 1)).	
	self assert: (32 = (db nbUlongAt: 1)).
	self assert: (0 = (mb nbUlongAt: 1)).
	
	ptr := self testLockSurface: surface handle pitch:  wb x: 0  y: 0  w:  100 h: 100.
	self assert: (wb nbUlongAt: 1) = surface stride.
	self assert: ptr = surface getDataPtr! !

!AthensCairoSurface class methodsFor: 'private' stamp: ''!
unregisterSurfaceWithId: anAthensCairoSurfaceId

	self ioUnregisterSurface: anAthensCairoSurfaceId! !

!AthensCairoSurface class methodsFor: 'instance creation' stamp: 'IgorStasenko 12/20/2011 15:02'!
width: aWidth height: aHeight
	^ (self primWidth: aWidth height: aHeight) initialize! !

!AthensCairoSurface methodsFor: 'converting' stamp: 'FernandoOlivero 4/19/2012 14:03'!
asAthensPaintOn: aCanvas
	^ AthensCairoPatternSurfacePaint createForSurface: self.
 ! !

!AthensCairoSurface methodsFor: 'converting' stamp: 'IgorStasenko 4/26/2013 15:20'!
asForm

	"create a form and copy an image data there"
	self checkSession.
	
	self flush.
	^ Form extent: (self width@self height) depth: 32 bits: id! !

!AthensCairoSurface methodsFor: 'drawing' stamp: ''!
attemptToRecurseDrawing
	^ self ! !

!AthensCairoSurface methodsFor: 'caching' stamp: 'IgorStasenko 10/12/2012 03:24'!
cacheAt: anObject ifAbsentPut: aBlock
	"Answer an object from surface's cache identified by anObject,
	if there is no cached object under such identifier, evaluate a block
	and put it into cache. Then answer the result of evaluation.
	A surface using identity comparison for object identifiers.
	"
	^ CairoBackendCache soleInstance at: anObject ifAbsentPut: aBlock! !

!AthensCairoSurface methodsFor: 'private' stamp: 'IgorStasenko 4/26/2013 15:21'!
checkSession

	session  == Smalltalk session ifFalse: [ 
		
		self error: 'Attempt to use invalid external resource (left from previous session)'
		
		 ]! !

!AthensCairoSurface methodsFor: 'accessing' stamp: 'IgorStasenko 10/9/2012 19:22'!
clear
	^ self clear: Color transparent! !

!AthensCairoSurface methodsFor: 'accessing' stamp: 'IgorStasenko 10/11/2012 18:05'!
clear: clearPaint
	currentCanvas pathTransform restoreAfter: [
		currentCanvas pathTransform loadIdentity.
		currentCanvas paintMode restoreAfter: [
			currentCanvas paintMode source.
			currentCanvas 
				setPaint: clearPaint;
				drawShape: (0@0 extent: self extent).
				
        ]].

! !

!AthensCairoSurface methodsFor: 'paints' stamp: 'BenjaminVanRyseghem 7/3/2013 13:29'!
createFormPaint: aForm 
	"here we should convert form to cairo surface"
	
	| newSurface |

	newSurface := self class fromForm: (aForm asFormOfDepth: 32).
	
	^ newSurface asAthensPaintOn: context

! !

!AthensCairoSurface methodsFor: 'paints' stamp: 'IgorStasenko 4/12/2013 10:05'!
createLinearGradient: aColorRamp origin: aStart corner: aStop

	self 
		deprecated: 'Use #createLinearGradient:start:stop: instead'
		on: 	'12 April 2013'
		in: 'ConfigurationOfAthens 2.0'.
		
	^self createLinearGradient: aColorRamp start: aStart stop: aStop! !

!AthensCairoSurface methodsFor: 'paints' stamp: 'IgorStasenko 4/12/2013 10:01'!
createLinearGradient: aColorRamp start: aStartPoint stop: aStopPoint
	^ AthensCairoGradientPaint 
		createLinearGradient: aColorRamp 
		start: aStartPoint 
		stop: aStopPoint
	! !

!AthensCairoSurface methodsFor: 'creation' stamp: 'FernandoOlivero 3/26/2012 18:47'!
createPath: aPathCreatingBlock
	^ builder createPath:  aPathCreatingBlock ! !

!AthensCairoSurface methodsFor: 'paints' stamp: 'IgorStasenko 4/27/2012 12:25'!
createRadialGradient: colorRamp center: aCenter radius: aRadius focalPoint: fp
	^AthensCairoGradientPaint	
		radialBetween: fp
		extending: 0
		and: aCenter
		extending: aRadius
		withColorRamp: colorRamp! !

!AthensCairoSurface methodsFor: 'paints' stamp: 'FernandoOlivero 1/13/2012 20:12'!
createSolidColorPaint: aColor 

	^ AthensCairoSolidPaint new color: aColor! !

!AthensCairoSurface methodsFor: 'paints' stamp: 'IgorStasenko 4/27/2012 11:22'!
createStrokePaintFor: aPaint

	^ AthensCairoStrokePaint new fillPaint: aPaint! !

!AthensCairoSurface methodsFor: 'drawing' stamp: 'IgorStasenko 4/26/2013 15:19'!
drawDuring: aBlock

	"You may draw on receiver only when inside a block and only using provided canvas object.
	This ensures releasing system resources used after finishing drawing"

	self checkSession.
	
	currentCanvas ifNotNil: [ self attemptToRecurseDrawing ].
	[
		currentCanvas := context.
		self privSetDefaults.
		aBlock value: currentCanvas.
		self flush.
	] ensure: [
		currentCanvas := nil.
	].! !

!AthensCairoSurface methodsFor: 'accessing' stamp: 'IgorStasenko 12/20/2011 15:18'!
extent
	^ self width @ self height! !

!AthensCairoSurface methodsFor: 'private' stamp: 'IgorStasenko 5/4/2012 18:32'!
flush

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #( void cairo_surface_flush (self) )! !

!AthensCairoSurface methodsFor: 'caching' stamp: 'IgorStasenko 10/12/2012 03:54'!
flushCacheAt: anObject

	"Flush (delete) any cached value(s) identified by given object, anObject.
	Do nothing if there's no cached values stored for given object.
	Answer receiver.

	A surface using identity comparison for object identifiers.
	"
	CairoBackendCache soleInstance removeAt: anObject! !

!AthensCairoSurface methodsFor: 'accessing' stamp: 'IgorStasenko 12/20/2011 15:19'!
getDataPtr
	"get a pointer to surface bitmap data"
	
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #(
		void* cairo_image_surface_get_data ( self ) )

! !

!AthensCairoSurface methodsFor: 'text support' stamp: 'IgorStasenko 9/2/2012 00:50'!
getFreetypeFontRendererFor: aFreetypeFont 
	"answer the same instance, just reset it's font and advance"
	
	^ ftFontRenderer font: aFreetypeFont; advance: 0@0; yourself! !

!AthensCairoSurface methodsFor: 'accessing' stamp: ''!
handle
	^ handle value! !

!AthensCairoSurface methodsFor: 'accessing' stamp: 'IgorStasenko 12/20/2011 15:12'!
height
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #(
		int cairo_image_surface_get_height ( self ) )

! !

!AthensCairoSurface methodsFor: 'initialize-release' stamp: 'IgorStasenko 4/26/2013 15:19'!
initialize
	"the handle should be set already since we using an NB callout to create an instance"
	handle value = 0 ifTrue: [ 
		self error: 'Error creating new surface' ].
	
	session := Smalltalk session.
	
	id := self class registerSurface: self.
		
	context := self newCanvas.
	builder := AthensCairoPathBuilder new.
	builder context: context.
	ftFontRenderer := CairoFreetypeFontRenderer new
		canvas: context. 
	
	NBExternalResourceManager addResource: self.! !

!AthensCairoSurface methodsFor: 'testing' stamp: 'FernandoOlivero 1/12/2012 11:59'!
isSuccess
	^ self status  =	CAIRO_STATUS_SUCCESS! !

!AthensCairoSurface methodsFor: 'private' stamp: 'IgorStasenko 8/31/2012 00:37'!
markDirty

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #( void cairo_surface_mark_dirty (self) )! !

!AthensCairoSurface methodsFor: 'nb helper' stamp: 'IgorStasenko 12/16/2011 11:38'!
nbLibraryNameOrHandle
	^ self class nbLibraryNameOrHandle
! !

!AthensCairoSurface methodsFor: 'private' stamp: 'IgorStasenko 10/17/2012 17:15'!
newCanvas
	"Answer a preinitialized instance of AthensCanvas.
	Private to receiver and its subclasses, override seldom"
	
	^ self primCreateCanvas surface: self

! !

!AthensCairoSurface methodsFor: 'private' stamp: 'IgorStasenko 10/17/2012 17:15'!
primCreateCanvas

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	^self nbCall: #( AthensCairoCanvas cairo_create (self) )! !

!AthensCairoSurface methodsFor: 'private' stamp: 'IgorStasenko 4/3/2013 06:22'!
privSetDefaults
	"reset matrices"
	currentCanvas pathTransform loadIdentity.
	currentCanvas paintTransform loadIdentity.
	currentCanvas resetDash.
	currentCanvas paintMode over.
	
	currentCanvas primSetLineJoin: CAIRO_LINE_JOIN_MITER.
	currentCanvas primSetLineCap: CAIRO_LINE_CAP_BUTT.
	currentCanvas primSetLineWidth: 1.0.
! !

!AthensCairoSurface methodsFor: 'initialize-release' stamp: 'IgorStasenko 5/31/2012 01:48'!
resourceData
	^ { handle value. id. context handle }! !

!AthensCairoSurface methodsFor: 'accessing' stamp: 'FernandoOlivero 1/12/2012 11:55'!
status

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #(int cairo_surface_status (self) )
	! !

!AthensCairoSurface methodsFor: 'private' stamp: 'FernandoOlivero 1/12/2012 12:00'!
statusToString: aCairoStatusT
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(String   cairo_status_to_string  (cairo_status_t aCairoStatusT))! !

!AthensCairoSurface methodsFor: 'accessing' stamp: 'IgorStasenko 12/20/2011 15:10'!
stride
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #(
		int cairo_image_surface_get_stride ( self ) )

! !

!AthensCairoSurface methodsFor: 'accessing' stamp: 'IgorStasenko 12/20/2011 15:12'!
width
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #(
		int cairo_image_surface_get_width ( self ) )

! !

!AthensCairoSurface methodsFor: 'converting' stamp: 'FernandoOlivero 1/12/2012 12:54'!
writeToPng: aFileName
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	self nbCall: #(void cairo_surface_write_to_png (self, String aFileName) )
! !

AthensCairoSurface subclass: #AthensQuartzSurface
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Cairo-Quartz'!

!AthensQuartzSurface commentStamp: '<historical>' prior: 0!
The Quartz surface is used to render cairo graphics targeting the Apple OS X Quartz rendering system.
!

!AthensQuartzSurface class methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 10/17/2012 17:36'!
finalizeResourceData: data
	| handle contextHandle |
	handle := data first.
	"	id := data second.  - id is not used "
	contextHandle := data third.
	
	self destroyContextHandle: contextHandle. 
	self destroySurfaceHandle: handle.
! !

!AthensQuartzSurface class methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 10/17/2012 17:02'!
primImage: aFormat width: aWidth height: aHeight
"Creates a Quartz surface backed by a CGBitmap. The surface is created using the Device RGB (or Device Gray, for A8) color space. All Cairo operations, including those that require software rendering, will succeed on this surface. "

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #(AthensQuartzSurface  cairo_quartz_surface_create (int aFormat,
                                                         int aWidth,
                                                         int aHeight) )

! !

!AthensQuartzSurface class methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 10/17/2012 17:33'!
registerSurface: quartzSurface
	"we cannot use SurfacePlugin for quartz surfaces"
	
	^ nil ! !

NBExternalObject subclass: #CairoFontOptions
	uses: TCairoLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'AthensCairoDefs'
	category: 'Athens-Cairo-Text'!

!CairoFontOptions commentStamp: '<historical>' prior: 0!
i represent various font options exposed by cairo library!

CairoFontOptions class
	uses: TCairoLibrary classTrait
	instanceVariableNames: ''!

!CairoFontOptions class methodsFor: 'finalizing' stamp: 'IgorStasenko 8/28/2012 12:11'!
finalizeResourceData: aData
	"finalize the external resource data, returned by #resourceData on instance side"
	
	self primDestroy: aData! !

!CairoFontOptions class methodsFor: 'instance creation' stamp: 'IgorStasenko 8/28/2012 12:06'!
new
	^ self primCreate initialize! !

!CairoFontOptions class methodsFor: 'private' stamp: 'IgorStasenko 8/28/2012 12:05'!
primCreate
"cairo_font_options_t * cairo_font_options_create        (void);

Allocates a new font options object with all options initialized to default values.

Returns :
	a newly allocated cairo_font_options_t. Free with cairo_font_options_destroy(). This function always returns a valid pointer; if memory cannot be allocated, then a special error object is returned where all operations on the object do nothing. You can check for this with cairo_font_options_status().

"	
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	^ self nbCall: #(CairoFontOptions cairo_font_options_create ())! !

!CairoFontOptions class methodsFor: 'private' stamp: 'IgorStasenko 8/28/2012 12:09'!
primDestroy: anOptions
"void                cairo_font_options_destroy          (cairo_font_options_t *options);

Destroys a cairo_font_options_t object created with cairo_font_options_create() or cairo_font_options_copy().

options :
	a cairo_font_options_t"

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	^ self nbCall: #(void cairo_font_options_destroy (size_t anOptions))! !

!CairoFontOptions methodsFor: 'antialiasing' stamp: 'IgorStasenko 9/2/2012 01:28'!
aaBest

	^ self setAA: CAIRO_ANTIALIAS_BEST.! !

!CairoFontOptions methodsFor: 'antialiasing' stamp: 'IgorStasenko 9/2/2012 01:27'!
aaDefault

	^ self setAA: CAIRO_ANTIALIAS_DEFAULT.! !

!CairoFontOptions methodsFor: 'antialiasing' stamp: 'IgorStasenko 9/2/2012 01:28'!
aaFast

	^ self setAA: CAIRO_ANTIALIAS_FAST.! !

!CairoFontOptions methodsFor: 'antialiasing' stamp: 'IgorStasenko 9/2/2012 01:28'!
aaGood

	^ self setAA: CAIRO_ANTIALIAS_GOOD.! !

!CairoFontOptions methodsFor: 'antialiasing' stamp: 'IgorStasenko 9/2/2012 01:27'!
aaGray

	^ self setAA: CAIRO_ANTIALIAS_GRAY.! !

!CairoFontOptions methodsFor: 'antialiasing' stamp: 'IgorStasenko 9/2/2012 01:27'!
aaNone

	^ self setAA: CAIRO_ANTIALIAS_NONE.! !

!CairoFontOptions methodsFor: 'antialiasing' stamp: 'IgorStasenko 9/2/2012 01:28'!
aaSubpixel

	^ self setAA: CAIRO_ANTIALIAS_SUBPIXEL.! !

!CairoFontOptions methodsFor: 'hint options' stamp: 'IgorStasenko 9/2/2012 01:15'!
hintStyleDefault
	^ self setHintStyle: CAIRO_HINT_STYLE_DEFAULT! !

!CairoFontOptions methodsFor: 'hint options' stamp: 'IgorStasenko 9/2/2012 01:16'!
hintStyleFull
	^ self setHintStyle: CAIRO_HINT_STYLE_FULL! !

!CairoFontOptions methodsFor: 'hint options' stamp: 'IgorStasenko 9/2/2012 01:15'!
hintStyleMedium
	^ self setHintStyle: CAIRO_HINT_STYLE_MEDIUM! !

!CairoFontOptions methodsFor: 'hint options' stamp: 'IgorStasenko 9/2/2012 01:15'!
hintStyleNone
	^ self setHintStyle: CAIRO_HINT_STYLE_NONE! !

!CairoFontOptions methodsFor: 'hint options' stamp: 'IgorStasenko 9/2/2012 01:15'!
hintStyleSlight
	^ self setHintStyle: CAIRO_HINT_STYLE_SLIGHT! !

!CairoFontOptions methodsFor: 'initialize-release' stamp: 'IgorStasenko 9/2/2012 01:16'!
initialize 
	self registerAsExternalResource.
	self setDefaults! !

!CairoFontOptions methodsFor: 'initialize-release' stamp: 'IgorStasenko 8/28/2012 12:07'!
resourceData

	^ handle value! !

!CairoFontOptions methodsFor: 'antialiasing' stamp: 'IgorStasenko 9/2/2012 01:29'!
setAA: antialias

"cairo_font_options_set_antialias ()

void                cairo_font_options_set_antialias    (cairo_font_options_t *options,
                                                         cairo_antialias_t antialias);

Sets the antialiasing mode for the font options object. This specifies the type of antialiasing to do when rendering text.

options :
	a cairo_font_options_t

antialias :
	the new antialiasing mode"
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	^ self nbCall: #( 
	void cairo_font_options_set_antialias (self, uint antialias))
! !

!CairoFontOptions methodsFor: 'defaults' stamp: 'IgorStasenko 10/11/2012 18:46'!
setDefaults

	self hintStyleNone; subpixelOrderRGB; aaSubpixel! !

!CairoFontOptions methodsFor: 'hint options' stamp: 'IgorStasenko 9/2/2012 01:14'!
setHintStyle: aStyle
	"cairo_font_options_set_hint_style ()

void                cairo_font_options_set_hint_style   (cairo_font_options_t *options,
                                                         cairo_hint_style_t hint_style);

Sets the hint style for font outlines for the font options object. This controls whether to fit font outlines to the pixel grid, and if so, whether to optimize for fidelity or contrast. See the documentation for cairo_hint_style_t for full details. "
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	^ self nbCall: #( 
		void cairo_font_options_set_hint_style (self, uint aStyle))

 ! !

!CairoFontOptions methodsFor: 'subpixel order' stamp: 'IgorStasenko 9/2/2012 19:50'!
setSubpixelOrder: order
	"void cairo_font_options_set_subpixel_order
		(cairo_font_options_t *options,
		cairo_subpixel_order_t subpixel_order)"
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	^ self nbCall: #(
		void cairo_font_options_set_subpixel_order (self, uint order))
 ! !

!CairoFontOptions methodsFor: 'subpixel order' stamp: 'IgorStasenko 9/2/2012 19:26'!
subpixelOrderBGR
	^ self setSubpixelOrder: CAIRO_SUBPIXEL_ORDER_BGR! !

!CairoFontOptions methodsFor: 'subpixel order' stamp: 'IgorStasenko 9/2/2012 19:25'!
subpixelOrderDefault
	^ self setSubpixelOrder: CAIRO_SUBPIXEL_ORDER_DEFAULT! !

!CairoFontOptions methodsFor: 'subpixel order' stamp: 'IgorStasenko 9/2/2012 19:25'!
subpixelOrderRGB
	^ self setSubpixelOrder: CAIRO_SUBPIXEL_ORDER_RGB! !

!CairoFontOptions methodsFor: 'subpixel order' stamp: 'IgorStasenko 9/2/2012 19:26'!
subpixelOrderVBGR
	^ self setSubpixelOrder: CAIRO_SUBPIXEL_ORDER_VBGR! !

!CairoFontOptions methodsFor: 'subpixel order' stamp: 'IgorStasenko 9/2/2012 19:26'!
subpixelOrderVRGB
	^ self setSubpixelOrder: CAIRO_SUBPIXEL_ORDER_VRGB! !

NBExternalObject subclass: #CairoScaledFont
	uses: TCairoLibrary
	instanceVariableNames: 'face'
	classVariableNames: ''
	poolDictionaries: 'AthensCairoDefs'
	category: 'Athens-Cairo-Text'!

!CairoScaledFont commentStamp: '<historical>' prior: 0!
my instances map to
cairo_scaled_font_t * 
data type!

CairoScaledFont class
	uses: TCairoLibrary classTrait
	instanceVariableNames: ''!

!CairoScaledFont class methodsFor: 'finalizing' stamp: 'IgorStasenko 6/11/2012 06:50'!
finalizeResourceData: handle

"
void                cairo_scaled_font_destroy           (cairo_scaled_font_t *scaled_font);
"
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	^ self nbCall: #( void  cairo_scaled_font_destroy (size_t handle) )! !

!CairoScaledFont class methodsFor: 'instance creation' stamp: 'IgorStasenko 9/2/2012 18:44'!
fromFreetypeFont: aFont cairoFace: face

	| options fontMatrix deviceMatrix font |

	options := CairoBackendCache soleInstance 
		at: #AAOptions ifAbsentPut: [ CairoFontOptions new ].
	fontMatrix := AthensCairoMatrix new.
	deviceMatrix := AthensCairoMatrix new.
	fontMatrix scaleBy: aFont getPreciseHeight.
	
	font := self primCreate: face fontMatrix: fontMatrix  userToDeviceMatrix: deviceMatrix options: options. 
	
	"to keep a reference to cairo face in instance"
	^ font initWithFace: face.
	
! !

!CairoScaledFont class methodsFor: 'private' stamp: 'IgorStasenko 8/28/2012 12:18'!
primCreate: face fontMatrix: fontMatrix userToDeviceMatrix: ctm options: options
"
cairo_scaled_font_t * cairo_scaled_font_create          (cairo_font_face_t *font_face,
                                                         const cairo_matrix_t *font_matrix,
                                                         const cairo_matrix_t *ctm,
                                                         const cairo_font_options_t *options);


 Creates a cairo_scaled_font_t object from a font face and matrices that describe the size of the font and the environment in which it will be used.

font_face :
	a cairo_font_face_t

font_matrix :
	font space to user space transformation matrix for the font. In the simplest case of a N point font, this matrix is just a scale by N, but it can also be used to shear the font or stretch it unequally along the two axes. See cairo_set_font_matrix().

ctm :
	user to device transformation matrix with which the font will be used.

options :
	options to use when getting metrics for the font and rendering with it.

Returns :
	a newly created cairo_scaled_font_t. Destroy with cairo_scaled_font_destroy()
"
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	^ self nbCall: #( 
		CairoScaledFont cairo_scaled_font_create (
			CairoFontFace face,
			AthensCairoMatrix * fontMatrix,
			AthensCairoMatrix * ctm,
			CairoFontOptions  options ) )
 ! !

!CairoScaledFont methodsFor: 'accessing' stamp: 'IgorStasenko 8/28/2012 11:26'!
extents
	| extents |
	extents := CairoFontExtents new.

	self getExtents: extents.
	
	^ extents! !

!CairoScaledFont methodsFor: 'accessing' stamp: 'IgorStasenko 6/11/2012 06:58'!
getExtents: cairoFontExtents
	"void                cairo_scaled_font_extents           (cairo_scaled_font_t *scaled_font,
                                                         cairo_font_extents_t *extents);
	"
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	^ self nbCall: #(int cairo_scaled_font_extents (self, CairoFontExtents * cairoFontExtents ))
		! !

!CairoScaledFont methodsFor: 'initialize-release' stamp: 'IgorStasenko 8/28/2012 12:28'!
initWithFace: cairo_face

	face := cairo_face.
	
	self registerAsExternalResource.! !

!CairoScaledFont methodsFor: 'initialize-release' stamp: 'IgorStasenko 8/28/2012 12:34'!
initialize 

	self status ~= CAIRO_STATUS_SUCCESS ifTrue: [ self error: 'Something is wrong!!' ].
		
	self registerAsExternalResource ! !

!CairoScaledFont methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 9/1/2012 23:33'!
lock

"
FT_Face             cairo_ft_scaled_font_lock_face      (cairo_scaled_font_t *scaled_font);

"
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	^ self nbCall: #( 
		void cairo_ft_scaled_font_lock_face (self)) ! !

!CairoScaledFont methodsFor: 'external resource management' stamp: 'IgorStasenko 6/11/2012 06:49'!
resourceData 
	^ handle value! !

!CairoScaledFont methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 9/1/2012 23:02'!
set_CTM: matrix

"
cairo_font_face_t * cairo_ft_font_face_create_for_ft_face
                                                        (FT_Face face,
                                                         int load_flags);
"
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	^ self nbCall: #( CairoFontFace cairo_ft_font_face_create_for_ft_face(uint aFace , int flags )) ! !

!CairoScaledFont methodsFor: 'accessing' stamp: 'IgorStasenko 6/11/2012 06:51'!
status
"cairo_status_t      cairo_scaled_font_status            (cairo_scaled_font_t *scaled_font);"
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	^ self nbCall: #(int cairo_scaled_font_status (self))
		! !

!CairoScaledFont methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 9/1/2012 23:33'!
unlock

"
FT_Face             cairo_ft_scaled_font_lock_face      (cairo_scaled_font_t *scaled_font);

"
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	^ self nbCall: #( 
		void cairo_ft_scaled_font_unlock_face  (self)) ! !

AthensPaintMode subclass: #AthensCairoPaintMode
	uses: TCairoLibrary
	instanceVariableNames: 'canvas'
	classVariableNames: ''
	poolDictionaries: 'AthensCairoDefs'
	category: 'Athens-Cairo'!

!AthensCairoPaintMode commentStamp: '<historical>' prior: 0!
I control the paint modes supported by Cairo backend.

for the list and description of paint modes supported by Cairo library, see
http://cairographics.org/operators/!

AthensCairoPaintMode class
	uses: TCairoLibrary classTrait
	instanceVariableNames: ''!

!AthensCairoPaintMode methodsFor: 'modes' stamp: 'IgorStasenko 9/1/2012 17:12'!
add
	
	^ self setOperator: CAIRO_OPERATOR_ADD! !

!AthensCairoPaintMode methodsFor: 'modes' stamp: 'IgorStasenko 9/1/2012 17:11'!
atop
	
	^ self setOperator: CAIRO_OPERATOR_ATOP! !

!AthensCairoPaintMode methodsFor: 'capabilities' stamp: 'IgorStasenko 9/1/2012 17:18'!
availableModes

	^ #(
		clear
		source
		over
		in
		out 
		atop
		dest
		destOver
		destIn
		destOut
		destAtop
		xor
		add
		saturate
		multiply
		screen
		overlay
		darken
		lighten
		colorDodge
		colorBurn
		hardLight
		softLight
		difference
		exclusion
		hslHue
		hslSaturation
		hslColor
		hslLuminosity
	)! !

!AthensCairoPaintMode methodsFor: 'initialize-release' stamp: 'IgorStasenko 9/1/2012 15:32'!
canvas: aCanvas
	canvas := aCanvas! !

!AthensCairoPaintMode methodsFor: 'modes' stamp: 'IgorStasenko 9/1/2012 16:00'!
clear
	"Set 'clear' drawing mode.
	
	Drawing under this mode will clear the surface under the shape boundaries"
	
	^ self setOperator: CAIRO_OPERATOR_CLEAR! !

!AthensCairoPaintMode methodsFor: 'modes' stamp: 'IgorStasenko 9/1/2012 17:14'!
colorBurn
	
	^ self setOperator: CAIRO_OPERATOR_COLOR_BURN! !

!AthensCairoPaintMode methodsFor: 'modes' stamp: 'IgorStasenko 9/1/2012 17:14'!
colorDodge
	
	^ self setOperator: CAIRO_OPERATOR_COLOR_DODGE! !

!AthensCairoPaintMode methodsFor: 'modes' stamp: 'IgorStasenko 9/1/2012 17:13'!
darken
	
	^ self setOperator: CAIRO_OPERATOR_DARKEN! !

!AthensCairoPaintMode methodsFor: 'modes' stamp: 'IgorStasenko 9/1/2012 16:01'!
dest
	"Set 'dest' drawing mode.
	
	Drawing under this mode will ignore the source, as if nothing drawn"
		
	^ self setOperator: CAIRO_OPERATOR_DEST! !

!AthensCairoPaintMode methodsFor: 'modes' stamp: 'IgorStasenko 9/1/2012 17:12'!
destAtop
	
	^ self setOperator: CAIRO_OPERATOR_DEST_ATOP! !

!AthensCairoPaintMode methodsFor: 'modes' stamp: 'IgorStasenko 9/1/2012 17:12'!
destIn
	
	^ self setOperator: CAIRO_OPERATOR_DEST_IN! !

!AthensCairoPaintMode methodsFor: 'modes' stamp: 'IgorStasenko 9/1/2012 17:12'!
destOut
	
	^ self setOperator: CAIRO_OPERATOR_DEST_OUT! !

!AthensCairoPaintMode methodsFor: 'modes' stamp: 'IgorStasenko 9/1/2012 17:11'!
destOver
	
	^ self setOperator: CAIRO_OPERATOR_DEST_OVER! !

!AthensCairoPaintMode methodsFor: 'modes' stamp: 'IgorStasenko 9/1/2012 17:15'!
difference
	
	^ self setOperator: CAIRO_OPERATOR_DIFFERENCE! !

!AthensCairoPaintMode methodsFor: 'modes' stamp: 'IgorStasenko 9/1/2012 17:15'!
exclusion
	
	^ self setOperator: CAIRO_OPERATOR_EXCLUSION! !

!AthensCairoPaintMode methodsFor: 'private' stamp: 'IgorStasenko 9/1/2012 15:40'!
getOperator
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	^ self nbCall: #(
		cairo_operator_t cairo_get_operator (AthensCairoCanvas canvas) )
! !

!AthensCairoPaintMode methodsFor: 'modes' stamp: 'IgorStasenko 9/1/2012 17:14'!
hardLight
	
	^ self setOperator: CAIRO_OPERATOR_HARD_LIGHT! !

!AthensCairoPaintMode methodsFor: 'modes' stamp: 'IgorStasenko 9/1/2012 17:15'!
hslColor
	
	^ self setOperator: CAIRO_OPERATOR_HSL_COLOR! !

!AthensCairoPaintMode methodsFor: 'modes' stamp: 'IgorStasenko 9/1/2012 17:15'!
hslHue
	
	^ self setOperator: CAIRO_OPERATOR_HSL_HUE! !

!AthensCairoPaintMode methodsFor: 'modes' stamp: 'IgorStasenko 9/1/2012 17:16'!
hslLuminosity
	
	^ self setOperator: CAIRO_OPERATOR_HSL_LUMINOSITY! !

!AthensCairoPaintMode methodsFor: 'modes' stamp: 'IgorStasenko 9/1/2012 17:15'!
hslSaturation
	
	^ self setOperator: CAIRO_OPERATOR_HSL_SATURATION! !

!AthensCairoPaintMode methodsFor: 'modes' stamp: 'IgorStasenko 9/1/2012 17:11'!
in
	
	^ self setOperator: CAIRO_OPERATOR_IN! !

!AthensCairoPaintMode methodsFor: 'modes' stamp: 'IgorStasenko 9/1/2012 17:14'!
lighten
	
	^ self setOperator: CAIRO_OPERATOR_LIGHTEN! !

!AthensCairoPaintMode methodsFor: 'modes' stamp: 'IgorStasenko 9/1/2012 17:13'!
multiply
	
	^ self setOperator: CAIRO_OPERATOR_MULTIPLY! !

!AthensCairoPaintMode methodsFor: 'modes' stamp: 'IgorStasenko 9/1/2012 17:11'!
out
	
	^ self setOperator: CAIRO_OPERATOR_OUT! !

!AthensCairoPaintMode methodsFor: 'modes' stamp: 'IgorStasenko 9/1/2012 16:01'!
over
	"Set 'over' drawing mode. This is default paint mode.
	
	Drawing under this mode will blend source with destination color using source alpha component"
			
	^ self setOperator: CAIRO_OPERATOR_OVER! !

!AthensCairoPaintMode methodsFor: 'modes' stamp: 'IgorStasenko 9/1/2012 17:13'!
overlay
	
	^ self setOperator: CAIRO_OPERATOR_OVERLAY! !

!AthensCairoPaintMode methodsFor: 'convenience' stamp: 'IgorStasenko 9/1/2012 15:36'!
restoreAfter: aBlock
	| op |
	op := self getOperator.
	
	aBlock ensure: [ self setOperator: op ]! !

!AthensCairoPaintMode methodsFor: 'modes' stamp: 'IgorStasenko 9/1/2012 17:13'!
saturate
	
	^ self setOperator: CAIRO_OPERATOR_SATURATE! !

!AthensCairoPaintMode methodsFor: 'modes' stamp: 'IgorStasenko 9/1/2012 17:13'!
screen
	
	^ self setOperator: CAIRO_OPERATOR_SCREEN! !

!AthensCairoPaintMode methodsFor: 'private' stamp: 'IgorStasenko 9/1/2012 15:37'!
setOperator: aCairoOperatorT
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	^ self nbCall: #(void cairo_set_operator (AthensCairoCanvas canvas, cairo_operator_t aCairoOperatorT) )
! !

!AthensCairoPaintMode methodsFor: 'modes' stamp: 'IgorStasenko 9/1/2012 17:14'!
softLight
	
	^ self setOperator: CAIRO_OPERATOR_SOFT_LIGHT! !

!AthensCairoPaintMode methodsFor: 'modes' stamp: 'IgorStasenko 9/1/2012 16:01'!
source
	"Set 'source' drawing mode.
	
	Drawing under this mode will replace the content with incoming source under the shape boundaries"
	
	^ self setOperator: CAIRO_OPERATOR_SOURCE! !

!AthensCairoPaintMode methodsFor: 'modes' stamp: 'IgorStasenko 9/1/2012 17:12'!
xor
	
	^ self setOperator: CAIRO_OPERATOR_XOR! !

AthensPaint subclass: #AthensCairoSolidPaint
	uses: TCairoLibrary
	instanceVariableNames: 'r g b a'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Cairo-Paints'!

!AthensCairoSolidPaint commentStamp: '<historical>' prior: 0!
i represent solid color paint in cairo backend!

AthensCairoSolidPaint class
	uses: TCairoLibrary classTrait
	instanceVariableNames: ''!

!AthensCairoSolidPaint methodsFor: 'accessing' stamp: 'IgorStasenko 3/28/2012 18:27'!
color: aColor
	r := aColor red.
	g := aColor green.
	b := aColor blue.
	a := aColor alpha.! !

!AthensCairoSolidPaint methodsFor: 'private' stamp: ''!
fillOn: aCanvas
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #(void cairo_fill (AthensCairoCanvas aCanvas ))
! !

!AthensCairoSolidPaint methodsFor: 'drawing' stamp: 'IgorStasenko 3/21/2012 19:03'!
fillPath: path on: anAthensCanvas 
	self loadOn: anAthensCanvas.
	anAthensCanvas
		newPath;
		loadPath: path.
		
	self fillOn: anAthensCanvas! !

!AthensCairoSolidPaint methodsFor: 'drawing' stamp: 'IgorStasenko 3/28/2012 18:22'!
fillRectangle: aRect on: anAthensCanvas
	"This is a terminal method in rendering dispatch scheme
	canvas->shape->paint. See AthensCanvas>>fillShape: "
	self loadOn: anAthensCanvas.
	anAthensCanvas 
		newPath;
		rectangleX: aRect left y: aRect top width: aRect width height: aRect height .
	self fillOn: anAthensCanvas! !

!AthensCairoSolidPaint methodsFor: 'private' stamp: 'IgorStasenko 4/3/2013 05:55'!
loadOn: anAthensCanvas
	anAthensCanvas
		setSourceR: r g: g b: b a: a; resetDash
	! !

NBExternalObject subclass: #CairoFontFace
	uses: TCairoLibrary
	instanceVariableNames: 'ftFace'
	classVariableNames: ''
	poolDictionaries: 'AthensCairoDefs FT2Constants'
	category: 'Athens-Cairo-Text'!

!CairoFontFace commentStamp: '<historical>' prior: 0!
I am a private class, used to represent a 'cairo_font_face_t *' data structure 
of Cairo library.

I am not useful for direct use nor providing any functionality. My only purpose is to keep a strong reference to original FT2Face object
(so it won't be freed before a corresponding instance of mine will release it).

!

CairoFontFace class
	uses: TCairoLibrary classTrait
	instanceVariableNames: ''!

!CairoFontFace class methodsFor: 'finalizing' stamp: 'IgorStasenko 6/11/2012 06:03'!
finalizeResourceData: handle

"
void                cairo_font_face_destroy             (cairo_font_face_t *font_face);
"
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	^ self nbCall: #( void cairo_font_face_destroy (size_t handle)) ! !

!CairoFontFace class methodsFor: 'instance creation' stamp: 'IgorStasenko 9/1/2012 22:48'!
fromFreetypeFace: aFace
	| handle cairoFace |
	
	handle := aFace handle nbUlongAt: 1.
	cairoFace := self primFtFace: handle loadFlags: (LoadIgnoreTransform "LoadNoScale "). 
	
	^ cairoFace initializeWithFreetypeFace: aFace! !

!CairoFontFace class methodsFor: 'instance creation' stamp: 'IgorStasenko 6/11/2012 05:33'!
ftFace: aFace loadFlags: flags

"
cairo_font_face_t * cairo_ft_font_face_create_for_ft_face
                                                        (FT_Face face,
                                                         int load_flags);

Creates a new font face for the FreeType font backend from a pre-opened FreeType face. This font can then be used with cairo_set_font_face() or cairo_scaled_font_create(). The cairo_scaled_font_t returned from cairo_scaled_font_create() is also for the FreeType backend and can be used with functions such as cairo_ft_scaled_font_lock_face(). Note that Cairo may keep a reference to the FT_Face alive in a font-cache and the exact lifetime of the reference depends highly upon the exact usage pattern and is subject to external factors. You must not call FT_Done_Face() before the last reference to the cairo_font_face_t has been dropped. 
"
	
	^ (self primFtFace: aFace  loadFlags: flags) initialize! !

!CairoFontFace class methodsFor: 'instance creation' stamp: 'IgorStasenko 6/11/2012 05:30'!
primFtFace: aFace loadFlags: flags

"
cairo_font_face_t * cairo_ft_font_face_create_for_ft_face
                                                        (FT_Face face,
                                                         int load_flags);
"
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	^ self nbCall: #( CairoFontFace cairo_ft_font_face_create_for_ft_face(uint aFace , int flags )) ! !

!CairoFontFace methodsFor: 'initialize-release' stamp: 'IgorStasenko 6/11/2012 06:00'!
initialize 
	
	self registerAsExternalResource ! !

!CairoFontFace methodsFor: 'initialize-release' stamp: 'IgorStasenko 8/28/2012 11:54'!
initializeWithFreetypeFace: aFace
	ftFace := aFace.
	
	self registerAsExternalResource.! !

!CairoFontFace methodsFor: 'external resource management' stamp: 'IgorStasenko 6/11/2012 06:00'!
resourceData 
	^ handle value! !

!CairoFontFace methodsFor: 'accessing' stamp: 'IgorStasenko 6/11/2012 06:29'!
status
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	^ self nbCall: #(int cairo_font_face_status (self))
		! !

AthensCanvas subclass: #AthensCairoCanvas
	instanceVariableNames: 'handle pathTransform paintTransform currentClipRect'
	classVariableNames: ''
	poolDictionaries: 'AthensCairoDefs'
	category: 'Athens-Cairo'!

!AthensCairoCanvas commentStamp: 'IgorStasenko 12/20/2011 15:58' prior: 0!
my instances representing a low-level cairo context and mapped to cairo_t * C type!

!AthensCairoCanvas class methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/20/2011 15:45'!
asNBExternalType: gen
	"use handle ivar to hold my instance (cairo_t)"
	^ NBExternalObjectType objectClass: self! !

!AthensCairoCanvas class methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/20/2011 16:12'!
nbLibraryNameOrHandle
	^ AthensCairoSurface nbLibraryNameOrHandle! !

!AthensCairoCanvas class methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/20/2011 16:14'!
on: cairoSurface

	^ (self primCreate: cairoSurface) surface: cairoSurface! !

!AthensCairoCanvas class methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/20/2011 16:14'!
primCreate: cairoSurface

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #( 
		AthensCairoCanvas cairo_create (AthensCairoSurface cairoSurface) )! !

!AthensCairoCanvas methodsFor: 'clipping' stamp: 'IgorStasenko 10/7/2012 23:06'!
clipBy: aRectangle during: aBlock
	| oldClip newClip |

	oldClip := currentClipRect.
	newClip := oldClip ifNil: [ aRectangle ] ifNotNil: [ oldClip intersect: aRectangle]. 
	
	self setPathMatrix; resetClip; setClipRect: newClip.
	
	currentClipRect := newClip.

	[aBlock value] ensure: [ 
		self 
		setPathMatrix;
		resetClip;
		setClipRect: oldClip. 
		currentClipRect := oldClip. ].
	
! !

!AthensCairoCanvas methodsFor: 'private' stamp: 'IgorStasenko 12/20/2011 15:56'!
destroy

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #( 	void cairo_destroy (self) )! !

!AthensCairoCanvas methodsFor: 'drawing' stamp: 'IgorStasenko 10/11/2012 18:42'!
draw
	"Fill the shape (anObject) using currently selected paint
	an object should implement double-dispatch to currently selected paint"
	
	"set the trasformation matrix"
	self setPathMatrix.
	
	^ shape paintFillsUsing: paint on: self

! !

!AthensCairoCanvas methodsFor: 'private' stamp: 'IgorStasenko 12/20/2011 16:10'!
fill
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #(void cairo_fill (self))
! !

!AthensCairoCanvas methodsFor: 'private' stamp: 'IgorStasenko 9/1/2012 19:45'!
getCurrentPoint

	| x y |
	"since we use pointers to floats we must create a copy of original values to not scratch them"
	x := 0.0 shallowCopy.
	y := 0.0 shallowCopy.
	self primGetCurrentPointX: x Y: y.
	^ x @ y
! !

!AthensCairoCanvas methodsFor: 'accessing' stamp: 'IgorStasenko 5/31/2012 01:47'!
handle
	^ handle value! !

!AthensCairoCanvas methodsFor: 'initialize-release' stamp: 'IgorStasenko 10/11/2012 18:45'!
initializeWithSurface: anAthensSurface	
	super initializeWithSurface: anAthensSurface.
	self paintMode default.! !

!AthensCairoCanvas methodsFor: 'private' stamp: 'IgorStasenko 3/8/2012 17:32'!
loadPath: aPath

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	 
	^ self nbCall: #( void cairo_append_path (self , AthensCairoPath aPath))
! !

!AthensCairoCanvas methodsFor: 'private' stamp: 'IgorStasenko 8/28/2012 18:19'!
moveToX: x Y: y
	" move command always starts a new contour "

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	^ self nbCall: #(void cairo_move_to (self, double x, double y ) )
! !

!AthensCairoCanvas methodsFor: 'library path' stamp: 'IgorStasenko 12/20/2011 16:11'!
nbLibraryNameOrHandle
	^ self class nbLibraryNameOrHandle
! !

!AthensCairoCanvas methodsFor: 'private' stamp: ''!
newPath
 
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	^ self nbCall: #( void cairo_new_path ( self ) )! !

!AthensCairoCanvas methodsFor: 'accessing' stamp: ''!
paintTransform
	^ paintTransform
! !

!AthensCairoCanvas methodsFor: 'accessing' stamp: 'IgorStasenko 12/20/2011 16:48'!
pathTransform
	^ pathTransform! !

!AthensCairoCanvas methodsFor: 'private' stamp: 'IgorStasenko 9/2/2012 20:55'!
primClip
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #(void cairo_clip (self))
! !

!AthensCairoCanvas methodsFor: 'private' stamp: 'IgorStasenko 9/1/2012 19:44'!
primGetCurrentPointX: x Y: y

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	^self nbCall: #( void cairo_get_current_point (self, double * x, double * y))! !

!AthensCairoCanvas methodsFor: 'private' stamp: 'IgorStasenko 3/30/2012 17:59'!
primGetSource
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	self nbCall: #( cairo_pattern_t cairo_get_source ( self ) )! !

!AthensCairoCanvas methodsFor: 'private' stamp: 'IgorStasenko 6/3/2012 04:02'!
primPaint
	"A drawing operator that paints the current source everywhere within the current clip region."
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	^ self nbCall: #(void cairo_paint (self))
! !

!AthensCairoCanvas methodsFor: 'private' stamp: 'IgorStasenko 4/3/2013 05:42'!
primResetDashes: anOffset
"	void                cairo_set_dash                      (cairo_t *cr,
                                                         double *dashes,
                                                         int num_dashes,
                                                         double offset);"
<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	self nbCall: #(void cairo_set_dash (
				self,
				0,
				0,
				double anOffset) )
! !

!AthensCairoCanvas methodsFor: 'private' stamp: 'IgorStasenko 4/3/2013 06:23'!
primSetLineCap: capStyle
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #(void cairo_set_line_cap (
			self,
			cairo_line_cap_t capStyle) )! !

!AthensCairoCanvas methodsFor: 'private' stamp: 'IgorStasenko 4/3/2013 06:21'!
primSetLineJoin: joinStyle
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	self nbCall: #(void cairo_set_line_join (
			self,
			cairo_line_join_t joinStyle) )! !

!AthensCairoCanvas methodsFor: 'private' stamp: 'IgorStasenko 4/3/2013 06:23'!
primSetLineWidth: width
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	self nbCall: #(void cairo_set_line_width (
				self,
				double width) )
! !

!AthensCairoCanvas methodsFor: 'private' stamp: 'IgorStasenko 12/20/2011 16:05'!
rectangleX: x y: y width: aWidth height: aHeight
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #(void cairo_rectangle (self,
		 double x, double y,
		 double aWidth, double aHeight) )
! !

!AthensCairoCanvas methodsFor: 'private' stamp: 'FernandoOlivero 1/17/2012 11:22'!
resetClip
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #(void cairo_reset_clip (self))
! !

!AthensCairoCanvas methodsFor: 'private' stamp: 'IgorStasenko 4/3/2013 05:55'!
resetDash
	self primResetDashes: 0.0! !

!AthensCairoCanvas methodsFor: 'private' stamp: 'IgorStasenko 9/2/2012 19:05'!
setAA: antiAlias

	"cairo_set_antialias ()

void                cairo_set_antialias                 (cairo_t *cr,
                                                         cairo_antialias_t antialias);

Set the antialiasing mode of the rasterizer used for drawing shapes. This value is a hint, and a particular backend may or may not support a particular value. At the current time, no backend supports CAIRO_ANTIALIAS_SUBPIXEL when drawing shapes.

Note that this option does not affect text rendering, instead see cairo_font_options_set_antialias().

"! !

!AthensCairoCanvas methodsFor: 'private' stamp: 'IgorStasenko 9/2/2012 22:18'!
setClipRect: aRectOrNil
	

	aRectOrNil 
		ifNil: [ self resetClip ]
		ifNotNil: [
			self newPath;
				rectangleX: aRectOrNil left
				y: aRectOrNil top
				width: aRectOrNil width
				height: aRectOrNil height;
				primClip
			]! !

!AthensCairoCanvas methodsFor: 'drawing text' stamp: 'IgorStasenko 9/1/2012 22:06'!
setFont: aFont
	fontRenderer := aFont glyphRendererOn: surface.
	^ fontRenderer! !

!AthensCairoCanvas methodsFor: 'private' stamp: 'IgorStasenko 9/1/2012 22:45'!
setFontSize: aSize
	"
	void                cairo_set_font_size                 (cairo_t *cr,
                                                         double size);
	"
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	^ self nbCall: #( void cairo_set_font_size (self , double aSize ))
! !

!AthensCairoCanvas methodsFor: 'private' stamp: 'IgorStasenko 5/31/2012 01:53'!
setPathMatrix
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #(void cairo_set_matrix (self,
			AthensCairoMatrix * pathTransform) )
! !

!AthensCairoCanvas methodsFor: 'private' stamp: 'IgorStasenko 9/1/2012 18:43'!
setPathMatrix: aMatrix
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #(void cairo_set_matrix (self,
			AthensCairoMatrix * aMatrix) )
! !

!AthensCairoCanvas methodsFor: 'private' stamp: 'IgorStasenko 8/28/2012 14:01'!
setScaledFont: aFont
	"Replaces the current font face, font matrix, and font options in the cairo_t with those of the cairo_scaled_font_t. Except for some translation, the current CTM of the cairo_t should be the same as that of the cairo_scaled_font_t, which can be accessed using cairo_scaled_font_get_ctm().
 "
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	^ self nbCall: #( void cairo_set_scaled_font (self , CairoScaledFont aFont))
! !

!AthensCairoCanvas methodsFor: 'private' stamp: 'IgorStasenko 12/20/2011 16:17'!
setSourceR: red g: green b: blue a: alpha

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( 
		void cairo_set_source_rgba ( self ,
			double red,
			double green,
			double blue,
			double alpha) )! !

!AthensCairoCanvas methodsFor: 'private' stamp: 'IgorStasenko 8/28/2012 13:56'!
showText: anUTF8String
	"A drawing operator that generates the shape from a string of UTF-8 characters, rendered according to the current font_face, font_size (font_matrix), and font_options. "
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	^ self nbCall: #(void cairo_show_text (self, char * anUTF8String ))
! !

!AthensCairoCanvas methodsFor: 'accessing' stamp: 'IgorStasenko 9/2/2012 19:06'!
surface: aCairoSurface
	
	"initialize for given surface"
	surface := aCairoSurface.
	
	pathTransform := AthensCairoMatrix new.
	paintTransform := AthensCairoMatrix new.
	paintMode := AthensCairoPaintMode new canvas: self.
	
	self setAA: CAIRO_ANTIALIAS_SUBPIXEL.! !

!AthensCairoCanvas methodsFor: 'private' stamp: 'IgorStasenko 9/1/2012 19:39'!
text: utf8String extents: extentsObj 
"cairo_text_extents ()

void                cairo_text_extents                  (cairo_t *cr,
                                                         const char *utf8,
                                                         cairo_text_extents_t *extents);
"
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>

	^ self nbCall: #( void cairo_text_extents (self, char * utf8String, cairo_text_extents_t * extentsObj) )
	! !

!AthensCairoCanvas methodsFor: 'path segments visitor' stamp: 'FernandoOlivero 1/15/2012 14:58'!
visitCloseSegment: closeSegment
	self closePath! !

!AthensCairoCanvas methodsFor: 'path segments visitor' stamp: 'FernandoOlivero 2/14/2012 08:16'!
visitCubicSegment: anAthensCubicSegment
	|  destination controlPoint controlPoint2 |
	destination := anAthensCubicSegment to.
	controlPoint := anAthensCubicSegment via1.
	controlPoint2 := anAthensCubicSegment via2.
	self
		curveToX: destination x Y: destination y
		viaX: controlPoint x Y: controlPoint y
		andX: controlPoint2 x Y: controlPoint2 y
		 		
! !

!AthensCairoCanvas methodsFor: 'path segments visitor' stamp: 'IgorStasenko 12/20/2011 18:49'!
visitLineSegment: line

	^ self lineToX: line endPoint x Y: line endPoint y! !

!AthensCairoCanvas methodsFor: 'path segments visitor' stamp: 'IgorStasenko 12/20/2011 18:46'!
visitMoveSegment: mov 
	^ self moveToX: mov endPoint x Y: mov endPoint y! !

!AthensCairoCanvas methodsFor: 'path segments visitor' stamp: 'FernandoOlivero 2/14/2012 08:17'!
visitQuadSegment: anAthensCubicSegment
	| destination controlPoint |
	destination := anAthensCubicSegment to.
	controlPoint := anAthensCubicSegment via.
	self
		curveToX: destination x Y: destination y
		viaX: controlPoint x Y: controlPoint y
		 ! !

AthensAbstractPaint subclass: #CairoPNGPaint
	instanceVariableNames: 'fileName'
	classVariableNames: ''
	poolDictionaries: 'AthensCairoDefs'
	category: 'Athens-Cairo-Paints'!

!CairoPNGPaint commentStamp: '<historical>' prior: 0!
I am a surface paint with lazy initialization scheme, that i loading image from .png file
the first time i will be used.

<Do not use me, because i am really Cairo specific>!

!CairoPNGPaint class methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 1/12/2012 12:47'!
fileNamed: aFileName
	| image|
	image := self new.
	image initializeOnFileNamed: aFileName.
	^ image! !

!CairoPNGPaint methodsFor: 'converting' stamp: 'IgorStasenko 4/12/2013 09:09'!
asAthensPaintOn: anAthensCanvas

	| surface |

	 surface := AthensCairoSurface createFromFile: fileName ifFailed: [ :status | 

		status =  CAIRO_STATUS_READ_ERROR ifTrue: [ 
			self error: 'Cairo couldnt read the file named ', fileName ].
		status = CAIRO_STATUS_FILE_NOT_FOUND ifTrue: [
			self error: 'Cairo cant find the file named ', fileName ].

		^ self error: 'Cannot create surface. Cairo status code: ', status asString 
	].
	
	^ surface asAthensPaintOn: anAthensCanvas.
 ! !

!CairoPNGPaint methodsFor: 'initialize-release' stamp: 'FernandoOlivero 1/12/2012 12:47'!
initializeOnFileNamed: aFileName
	fileName := aFileName.! !

AthensTransform subclass: #AthensCairoTransform
	uses: TCairoLibrary
	instanceVariableNames: 'canvas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Cairo-Transforms'!

!AthensCairoTransform commentStamp: '<historical>' prior: 0!
i implement AthensTransform protocol using cairo-specific functions.!

AthensCairoTransform class
	uses: TCairoLibrary classTrait
	instanceVariableNames: ''!

!AthensCairoTransform class methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/20/2011 16:49'!
for: cairoCanvas
	^ self new canvas: cairoCanvas! !

!AthensCairoTransform methodsFor: 'initializing' stamp: 'IgorStasenko 12/20/2011 16:43'!
canvas: aCairoCanvas
	canvas := aCairoCanvas! !

!AthensCairoTransform methodsFor: 'primitives' stamp: 'IgorStasenko 12/20/2011 16:47'!
loadIdentity

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #(
		void cairo_identity_matrix (AthensCairoCanvas canvas) )

! !

!AthensCairoTransform methodsFor: 'transformations' stamp: 'FernandoOlivero 1/15/2012 19:39'!
moveTo: aPoint
	self moveToX: aPoint x asFloat Y: aPoint y asFloat! !

!AthensCairoTransform methodsFor: 'primitives' stamp: 'FernandoOlivero 1/14/2012 20:31'!
moveToX: px Y: py

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #(
		void cairo_move_to (AthensCairoCanvas canvas,
                                                         double px,
                                                         double py))

! !

!AthensCairoTransform methodsFor: 'primitives' stamp: 'IgorStasenko 12/21/2011 13:43'!
primTransformX: x Y: y

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #(
		void cairo_user_to_device (AthensCairoCanvas canvas,
                                                         NBFloatPtr x,
                                                         NBFloatPtr y) )
! !

!AthensCairoTransform methodsFor: 'primitives' stamp: 'FernandoOlivero 1/14/2012 00:32'!
restore
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #(void cairo_restore(AthensCairoCanvas canvas))
! !

!AthensCairoTransform methodsFor: 'transformations' stamp: 'IgorStasenko 3/7/2012 13:55'!
restoreAfter: aBlock
	self save.
	aBlock ensure:  [ self restore ].! !

!AthensCairoTransform methodsFor: 'transformations' stamp: 'IgorStasenko 12/20/2011 16:45'!
rotateByDegrees: angle

	^ self rotateByRadians: angle degreesToRadians! !

!AthensCairoTransform methodsFor: 'primitives' stamp: 'IgorStasenko 12/20/2011 16:45'!
rotateByRadians: angle

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #(
		void cairo_rotate (AthensCairoCanvas canvas,
                                                         double angle))

! !

!AthensCairoTransform methodsFor: 'primitives' stamp: 'FernandoOlivero 1/14/2012 00:32'!
save
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #(void cairo_save (AthensCairoCanvas canvas))
! !

!AthensCairoTransform methodsFor: 'transformations' stamp: 'FernandoOlivero 1/15/2012 16:49'!
scaleBy: aScalarOrPoint
	| double |
	aScalarOrPoint isPoint
		ifTrue:[
			self
				scaleX: aScalarOrPoint x asFloat
				Y: aScalarOrPoint y asFloat ]
		ifFalse:[ 
			double := aScalarOrPoint asFloat.
			self scaleX: double Y: double ].
! !

!AthensCairoTransform methodsFor: 'primitives' stamp: 'IgorStasenko 12/20/2011 16:44'!
scaleX: fx Y: fy

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #(
		void cairo_scale (AthensCairoCanvas canvas,
                                                         double fx,
                                                         double fy))

! !

!AthensCairoTransform methodsFor: 'vector-transform' stamp: 'IgorStasenko 12/21/2011 13:42'!
transform: aPoint
	| x y |
	"since we use pointers to floats we must create a copy of original values to not scratch them"
	x := aPoint x asFloat shallowCopy.
	y := aPoint y asFloat shallowCopy.
	
	self primTransformX: x Y: y.
	^ x @ y! !

!AthensCairoTransform methodsFor: 'transformations' stamp: 'FernandoOlivero 1/14/2012 00:38'!
translateBy: aPoint
	self translateX: aPoint x Y: aPoint y
! !

!AthensCairoTransform methodsFor: 'primitives' stamp: 'IgorStasenko 12/20/2011 16:54'!
translateX: px Y: py

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #(
		void cairo_translate (AthensCairoCanvas canvas,
                                                         double px,
                                                         double py))

! !

AthensStrokePaint subclass: #AthensCairoStrokePaint
	uses: TCairoLibrary
	instanceVariableNames: 'dashLenghts dashOffset'
	classVariableNames: ''
	poolDictionaries: 'AthensCairoDefs'
	category: 'Athens-Cairo-Paints'!

!AthensCairoStrokePaint commentStamp: '<historical>' prior: 0!
i represent stroke paint in cairo backend!

AthensCairoStrokePaint class
	uses: TCairoLibrary classTrait
	instanceVariableNames: ''!

!AthensCairoStrokePaint methodsFor: 'accessing' stamp: 'FernandoOlivero 1/12/2012 22:28'!
beBevel
	self joinStyle: CAIRO_LINE_JOIN_BEVEL! !

!AthensCairoStrokePaint methodsFor: 'accessing' stamp: 'FernandoOlivero 1/12/2012 22:45'!
beButt
	self capStyle: CAIRO_LINE_CAP_BUTT.! !

!AthensCairoStrokePaint methodsFor: 'accessing' stamp: 'FernandoOlivero 2/14/2012 12:02'!
beCapRound
	self capStyle: CAIRO_LINE_CAP_ROUND! !

!AthensCairoStrokePaint methodsFor: 'accessing' stamp: 'FernandoOlivero 3/25/2012 21:24'!
beJoinRound
	self joinStyle: CAIRO_LINE_JOIN_ROUND ! !

!AthensCairoStrokePaint methodsFor: 'accessing' stamp: 'FernandoOlivero 1/12/2012 22:29'!
beMiter
	self joinStyle: CAIRO_LINE_JOIN_MITER! !

!AthensCairoStrokePaint methodsFor: 'accessing' stamp: 'FernandoOlivero 1/12/2012 22:45'!
beSquare
	self capStyle: CAIRO_LINE_CAP_SQUARE! !

!AthensCairoStrokePaint methodsFor: 'setting cap styles' stamp: 'IgorStasenko 4/3/2013 05:15'!
capButt
	self capStyle: CAIRO_LINE_CAP_BUTT.! !

!AthensCairoStrokePaint methodsFor: 'setting cap styles' stamp: 'IgorStasenko 4/3/2013 05:16'!
capRound
	self capStyle: CAIRO_LINE_CAP_ROUND! !

!AthensCairoStrokePaint methodsFor: 'setting cap styles' stamp: 'IgorStasenko 4/3/2013 05:18'!
capSquare
	self capStyle: CAIRO_LINE_CAP_SQUARE! !

!AthensCairoStrokePaint methodsFor: 'accessing' stamp: 'IgorStasenko 4/3/2013 05:54'!
dashes: anAlternateCollectionOfLenghts offset: anOffset
	dashLenghts := anAlternateCollectionOfLenghts.
	dashOffset := anOffset asFloat.! !

!AthensCairoStrokePaint methodsFor: 'drawing' stamp: 'IgorStasenko 3/28/2012 18:21'!
fillPath: aPath on: anAthensCanvas
	self loadOn: anAthensCanvas.
	anAthensCanvas newPath; loadPath: aPath.
	self strokeOn: anAthensCanvas.
	! !

!AthensCairoStrokePaint methodsFor: 'drawing' stamp: 'IgorStasenko 3/28/2012 18:21'!
fillRectangle: aRect on: anAthensCanvas
	self loadOn: anAthensCanvas.
	anAthensCanvas 
		newPath;
		rectangleX: aRect left
		y: aRect top 
		width: aRect width
		height: aRect height.

	self strokeOn: anAthensCanvas.	
! !

!AthensCairoStrokePaint methodsFor: 'initialize-release' stamp: 'IgorStasenko 3/8/2012 17:24'!
initialize
	super initialize.

	width := 1.
	capStyle := joinStyle := nil.
! !

!AthensCairoStrokePaint methodsFor: 'setting join styles' stamp: 'IgorStasenko 4/3/2013 05:14'!
joinBevel
	self joinStyle: CAIRO_LINE_JOIN_BEVEL! !

!AthensCairoStrokePaint methodsFor: 'setting join styles' stamp: 'IgorStasenko 4/3/2013 05:16'!
joinMiter
	self joinStyle: CAIRO_LINE_JOIN_MITER! !

!AthensCairoStrokePaint methodsFor: 'setting join styles' stamp: 'IgorStasenko 4/3/2013 05:15'!
joinRound
	self joinStyle: CAIRO_LINE_JOIN_ROUND ! !

!AthensCairoStrokePaint methodsFor: 'drawing' stamp: 'IgorStasenko 4/3/2013 05:58'!
loadOn: aCanvas
	self fillPaint loadOn: aCanvas.
	self width notNil ifTrue:[ self primSetLineWidthOn: aCanvas].
	self joinStyle notNil ifTrue:[ self primSetLineJoinOn: aCanvas].
	self capStyle notNil ifTrue:[ self primSetLineCapOn: aCanvas].
	
	dashLenghts 
		ifNil: [ aCanvas resetDash ] 
		ifNotNil: [ self setDashesOn: aCanvas ].! !

!AthensCairoStrokePaint methodsFor: 'private' stamp: 'FernandoOlivero 1/12/2012 23:51'!
primSetDashesOn: aCanvas lengths: dashesLengths count: dashesCount offset: anOffset
"	void                cairo_set_dash                      (cairo_t *cr,
                                                         double *dashes,
                                                         int num_dashes,
                                                         double offset);"
<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	self nbCall: #(void cairo_set_dash (
				AthensCairoCanvas aCanvas,
				double* dashesLengths,
				int dashesCount,
				double anOffset) )
! !

!AthensCairoStrokePaint methodsFor: 'private' stamp: 'FernandoOlivero 1/12/2012 23:20'!
primSetLineCapOn: aCanvas
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #(void cairo_set_line_cap (
			AthensCairoCanvas aCanvas,
			cairo_line_cap_t capStyle) )! !

!AthensCairoStrokePaint methodsFor: 'private' stamp: 'FernandoOlivero 1/12/2012 23:21'!
primSetLineJoinOn: aCanvas
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	self nbCall: #(void cairo_set_line_join (
			AthensCairoCanvas aCanvas,
			cairo_line_join_t joinStyle) )! !

!AthensCairoStrokePaint methodsFor: 'private' stamp: 'FernandoOlivero 1/12/2012 23:19'!
primSetLineWidthOn: aCanvas
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	self nbCall: #(void cairo_set_line_width (
				AthensCairoCanvas aCanvas,
				double width) )
! !

!AthensCairoStrokePaint methodsFor: 'private' stamp: 'IgorStasenko 4/3/2013 05:53'!
setDashesOn: aCanvas 
	| buf |
	
	buf := ByteArray new: 8*dashLenghts size.
	
	dashLenghts withIndexDo: [:len :i |
		
		buf nbFloat64AtOffset: (i-1)*8 put: len asFloat
		].

	self
		primSetDashesOn: aCanvas
		lengths: buf
		count: dashLenghts size
		offset: dashOffset
		! !

!AthensCairoStrokePaint methodsFor: 'private' stamp: 'IgorStasenko 3/8/2012 17:24'!
strokeOn: aCanvas
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	self nbCall: #(void cairo_stroke(AthensCairoCanvas aCanvas))
! !

Object subclass: #AthensCairoText
	uses: TCairoLibrary
	instanceVariableNames: 'text fontFamily fontSlant fontWeight fontSize'
	classVariableNames: ''
	poolDictionaries: 'AthensCairoDefs'
	category: 'Athens-Cairo-Text'!

!AthensCairoText commentStamp: '<historical>' prior: 0!
do not use this class. this is subject of change or removal!

AthensCairoText class
	uses: TCairoLibrary classTrait
	instanceVariableNames: ''!

!AthensCairoText methodsFor: 'accessing' stamp: 'FernandoOlivero 1/14/2012 18:35'!
asString
	^ text asString! !

!AthensCairoText methodsFor: 'font description' stamp: 'FernandoOlivero 1/14/2012 18:23'!
beBold
	self fontWeight: CAIRO_FONT_WEIGHT_BOLD! !

!AthensCairoText methodsFor: 'font description' stamp: 'FernandoOlivero 1/14/2012 19:40'!
beNormal
	self fontWeight: CAIRO_FONT_WEIGHT_NORMAL! !

!AthensCairoText methodsFor: 'font description' stamp: 'FernandoOlivero 1/14/2012 18:23'!
beSlantNormal
	self fontSlant: CAIRO_FONT_SLANT_NORMAL! !

!AthensCairoText methodsFor: 'drawing' stamp: 'FernandoOlivero 4/7/2012 12:12'!
drawOn: aCanvas
	self loadOn: aCanvas.
	self showOn: aCanvas! !

!AthensCairoText methodsFor: 'font description' stamp: 'FernandoOlivero 1/14/2012 18:23'!
fontFamily

	^ fontFamily! !

!AthensCairoText methodsFor: 'font description' stamp: 'FernandoOlivero 1/14/2012 19:42'!
fontFamily: anObject
	"CSS2 generic family names: serif, sans-serif, cursive, fantasy, monospace"
	fontFamily := anObject! !

!AthensCairoText methodsFor: 'font description' stamp: 'FernandoOlivero 1/14/2012 18:23'!
fontSize

	^ fontSize! !

!AthensCairoText methodsFor: 'font description' stamp: 'FernandoOlivero 1/14/2012 18:23'!
fontSize: anObject

	fontSize := anObject! !

!AthensCairoText methodsFor: 'font description' stamp: 'FernandoOlivero 1/14/2012 18:24'!
fontSlant

	^ fontSlant! !

!AthensCairoText methodsFor: 'font description' stamp: 'FernandoOlivero 1/14/2012 20:00'!
fontSlant: anObject
	anObject isSymbol
		ifTrue:[ fontSlant := self slantFrom: anObject ]
		ifFalse:[ fontSlant := anObject ]! !

!AthensCairoText methodsFor: 'font description' stamp: 'FernandoOlivero 1/14/2012 18:24'!
fontWeight

	^ fontWeight! !

!AthensCairoText methodsFor: 'font description' stamp: 'FernandoOlivero 1/25/2012 01:03'!
fontWeight: anObject
	anObject isSymbol
		ifTrue:[ fontWeight := self weightFrom: anObject ]
		ifFalse:[ fontWeight :=  anObject ] ! !

!AthensCairoText methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 3/30/2012 14:49'!
initialize
	super initialize.
	
	self beNormal; beSlantNormal.
	 fontSize := 10.! !

!AthensCairoText methodsFor: 'drawing' stamp: 'FernandoOlivero 3/30/2012 14:49'!
loadOn: aCanvas
	fontFamily notNil ifTrue:[
		self
			primSelectFont:  fontFamily
				slant:  fontSlant
				weight:  fontWeight 
				on: aCanvas] .
	fontSize notNil ifTrue:[		
		self primSetFontSize:  fontSize on: aCanvas ]! !

!AthensCairoText methodsFor: 'as yet unclassified' stamp: ''!
nbLibraryNameOrHandle
	^ self class nbLibraryNameOrHandle
! !

!AthensCairoText methodsFor: 'private' stamp: 'FernandoOlivero 1/25/2012 01:00'!
primSelectFont: aFontFamily
		slant: aFontSlant
		weight: aFontWeight 
		on: aCanvas
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	self nbCall: #(void cairo_select_font_face (
			cairo_t aCanvas,
   			char * aFontFamily,
      		cairo_font_slant_t aFontSlant,
        	cairo_font_weight_t aFontWeight) )
	! !

!AthensCairoText methodsFor: 'private' stamp: 'FernandoOlivero 1/14/2012 18:31'!
primSetFontSize: aFontSize on: aCanvas
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	self nbCall: #(void cairo_set_font_size (
			cairo_t aCanvas,
			double aFontSize) )
! !

!AthensCairoText methodsFor: 'private' stamp: 'FernandoOlivero 1/25/2012 00:59'!
primShowText: aString on: aCanvas
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	self nbCall: #(void cairo_show_text (
			cairo_t aCanvas,
			char * aString) )
! !

!AthensCairoText methodsFor: 'font description' stamp: 'FernandoOlivero 1/14/2012 20:10'!
readFrom: aFontDescription
	self fontFamily: aFontDescription fontFamily.
	self fontSlant: aFontDescription fontSlant.
	self fontWeight:  aFontDescription fontWeight.
	self fontSize: aFontDescription fontSize.! !

!AthensCairoText methodsFor: 'drawing' stamp: 'FernandoOlivero 4/7/2012 12:12'!
showOn: aCanvas
	| cString|
	aCanvas setPathMatrix.
	cString := self asString copyWith: (Character value: 0).
	self primShowText: cString on: aCanvas! !

!AthensCairoText methodsFor: 'private' stamp: 'FernandoOlivero 1/25/2012 01:02'!
slantFrom: aSymbol
	^ aSymbol caseOf: {
		[#normal]->[ CAIRO_FONT_SLANT_NORMAL ].
 		[#italic]->[   CAIRO_FONT_SLANT_ITALIC ].
		[#oblique]->[ CAIRO_FONT_SLANT_OBLIQUE ] }! !

!AthensCairoText methodsFor: 'accessing' stamp: 'FernandoOlivero 1/14/2012 18:24'!
text

	^ text! !

!AthensCairoText methodsFor: 'accessing' stamp: 'FernandoOlivero 1/14/2012 18:24'!
text: anObject

	text := anObject! !

!AthensCairoText methodsFor: 'private' stamp: 'FernandoOlivero 1/25/2012 01:03'!
weightFrom: aSymbol
	^ aSymbol caseOf: {
		[#normal]->[ CAIRO_FONT_WEIGHT_NORMAL  ].
 		[#bold]->[    CAIRO_FONT_WEIGHT_BOLD ] }
! !

Object subclass: #AthensFontDescription
	instanceVariableNames: 'family options size'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Cairo-Text'!

!AthensFontDescription commentStamp: 'FernandoOlivero 1/24/2012 18:30' prior: 0!
Creates a new font description from a string representation in the form 
"[FAMILY-LIST] [STYLE-OPTIONS] [SIZE]", 

1)FAMILY-LIST is a comma separated list of families optionally terminated by a comma,

2)STYLE_OPTIONS is a whitespace separated list of words where each WORD describes one of style, variant, weight, stretch, or gravity. If STYLE-OPTIONS is missing, then all style options will be set to the default values

3)SIZE is a decimal number (size in points) or optionally followed by the unit modifier "px" for absolute size. 

!

!AthensFontDescription class methodsFor: 'examples' stamp: 'FernandoOlivero 1/24/2012 18:43'!
example
	| fDesc |
	fDesc := AthensFontDescription new. 
	fDesc
		family: 'monospace';
		fontSize: 22.
	^ fDesc! !

!AthensFontDescription methodsFor: 'accessing' stamp: 'FernandoOlivero 1/17/2012 16:31'!
asString
	"[FAMILY-LIST] [STYLE-OPTIONS] [SIZE]"
	| str |
	str := '' writeStream.
	str nextPutAll:  family; space.
	"	
2)STYLE_OPTIONS is a whitespace separated list of words where each WORD describes one of style, variant, weight, stretch, or gravity. If STYLE-OPTIONS is missing, then all style options will be set to the default values
"
	#(slant. variant. weight. stretch. gravity) do:[:each|
		|val|
		val := options at: each ifAbsent: nil.
		val notNil ifTrue:[str nextPutAll: val ; space ]].
	
	self fontSize notNil ifTrue:[
		str
			space;
			nextPutAll: self fontSize asString ].
	^ str contents! !

!AthensFontDescription methodsFor: 'accessing' stamp: 'FernandoOlivero 1/14/2012 20:07'!
beBold
	self weight: #bold! !

!AthensFontDescription methodsFor: 'accessing' stamp: 'FernandoOlivero 1/14/2012 20:06'!
beItalic
	self slant: #italic! !

!AthensFontDescription methodsFor: 'accessing' stamp: 'FernandoOlivero 1/14/2012 20:07'!
beNormal
	self slant: #normal ; weight: #normal.! !

!AthensFontDescription methodsFor: 'accessing' stamp: 'FernandoOlivero 1/14/2012 20:06'!
beOblique
	self slant: #oblique! !

!AthensFontDescription methodsFor: 'cairo-options' stamp: 'FernandoOlivero 1/14/2012 19:42'!
family: aFamilyName
	"CSS2 generic family names: serif, sans-serif, cursive, fantasy, monospace"
	family := aFamilyName.
	! !

!AthensFontDescription methodsFor: 'cairo-options' stamp: 'FernandoOlivero 1/14/2012 20:10'!
fontFamily
	^ family! !

!AthensFontDescription methodsFor: 'pango-options' stamp: 'FernandoOlivero 1/17/2012 16:26'!
fontGravity
	^ options at: #gravity! !

!AthensFontDescription methodsFor: 'cairo-options' stamp: 'FernandoOlivero 1/14/2012 20:09'!
fontSize
	^ size ! !

!AthensFontDescription methodsFor: 'cairo-options' stamp: 'FernandoOlivero 1/10/2012 12:12'!
fontSize: aPointSize
	size := aPointSize! !

!AthensFontDescription methodsFor: 'cairo-options' stamp: 'FernandoOlivero 1/25/2012 01:02'!
fontSlant
	^ options at: #slant ! !

!AthensFontDescription methodsFor: 'pango-options' stamp: 'FernandoOlivero 1/17/2012 16:26'!
fontStretch
	^ options at: #stretch! !

!AthensFontDescription methodsFor: 'pango-options' stamp: 'FernandoOlivero 1/17/2012 16:25'!
fontVariant
	^ options at: #variant ! !

!AthensFontDescription methodsFor: 'cairo-options' stamp: 'FernandoOlivero 1/14/2012 20:06'!
fontWeight
	^ options at: #weight ! !

!AthensFontDescription methodsFor: 'pango-options' stamp: 'FernandoOlivero 1/17/2012 16:28'!
gravity: aNumber
	options at: #gravity put: aNumber.		
! !

!AthensFontDescription methodsFor: 'initialize-release' stamp: 'FernandoOlivero 1/14/2012 20:08'!
initialize
	super initialize.
	family := 'monospace'.
	options := Dictionary new.
	options
		at:#weight put: #normal; 
		at:#slant put: #normal.
	size := 14.
	! !

!AthensFontDescription methodsFor: 'cairo-options' stamp: 'FernandoOlivero 1/14/2012 19:52'!
slant: aNumber
	options at: #slant put: aNumber.		
! !

!AthensFontDescription methodsFor: 'pango-options' stamp: 'FernandoOlivero 1/17/2012 16:28'!
stretch: aNumber
	options at: #stretch put: aNumber.		
! !

!AthensFontDescription methodsFor: 'pango-options' stamp: 'FernandoOlivero 1/17/2012 16:28'!
variant: aNumber
	options at: #variant put: aNumber.		
! !

!AthensFontDescription methodsFor: 'cairo-options' stamp: 'FernandoOlivero 1/14/2012 19:52'!
weight: aNumber
	options at: #weight put: aNumber.		
! !

Object subclass: #CairoBackendCache
	instanceVariableNames: 'cache'
	classVariableNames: ''
	poolDictionaries: 'AthensCairoDefs'
	category: 'Athens-Cairo'!

CairoBackendCache class
	instanceVariableNames: 'soleInstance'!

!CairoBackendCache commentStamp: '<historical>' prior: 0!
I providing a simple [weak]key->value storage used to cache various objects used by Athens for Cairo backend, like fonts/forms etc.

The cache is global (there's only a single instance of me used at a time) and
cache is visible globally by all entities of Cairo backend.

The cached objects is held weakly.
The cache is flushed for a new image session.!

CairoBackendCache class
	instanceVariableNames: 'soleInstance'!

!CairoBackendCache class methodsFor: 'class initialization' stamp: 'IgorStasenko 9/2/2012 01:57'!
initialize
	"self initialize "	
	soleInstance ifNotNil: [ NativeBoost announcer unsubscribe: soleInstance. soleInstance initialize ]. 
	soleInstance := self new.
	"be notified about session change"
	NativeBoost notifyAboutSessionChange: soleInstance! !

!CairoBackendCache class methodsFor: 'accessing' stamp: 'IgorStasenko 9/1/2012 23:55'!
soleInstance
	^ soleInstance! !

!CairoBackendCache methodsFor: 'accessing' stamp: 'IgorStasenko 9/2/2012 19:15'!
at: anObject 

	^ cache at: anObject  ifAbsent: nil! !

!CairoBackendCache methodsFor: 'accessing' stamp: 'IgorStasenko 9/2/2012 00:31'!
at: anObject ifAbsentPut: aBlock

	^ cache at: anObject  ifAbsentPut: aBlock! !

!CairoBackendCache methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/3/2013 13:26'!
flush

	cache := WeakIdentityKeyDictionary new! !

!CairoBackendCache methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/3/2013 13:25'!
for: anObject at: key ifAbsentPut: aBlock

	| subCache |
	subCache := cache 
		at: anObject
		ifAbsentPut: [ WeakIdentityKeyDictionary new ].

	^ subCache at: key ifAbsentPut: aBlock! !

!CairoBackendCache methodsFor: 'initialize-release' stamp: 'BenjaminVanRyseghem 7/3/2013 13:26'!
initialize

	self flush! !

!CairoBackendCache methodsFor: 'initialize-release' stamp: 'IgorStasenko 9/2/2012 01:54'!
nbSessionChanged

	self initialize.
	! !

!CairoBackendCache methodsFor: 'removing' stamp: 'IgorStasenko 10/12/2012 03:54'!
removeAt: anObject

	^ cache removeKey: anObject  ifAbsent: nil! !

Object subclass: #CairoFreetypeFontRenderer
	uses: TCairoLibrary
	instanceVariableNames: 'font surface utfConverter canvas advance originalFont cache'
	classVariableNames: ''
	poolDictionaries: 'AthensCairoDefs'
	category: 'Athens-Cairo-Text'!

!CairoFreetypeFontRenderer commentStamp: '<historical>' prior: 0!
i am used to render freetype font(s) with cairo library.!

CairoFreetypeFontRenderer class
	uses: TCairoLibrary classTrait
	instanceVariableNames: ''!

!CairoFreetypeFontRenderer methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 9/1/2012 21:29'!
advance
	^ advance! !

!CairoFreetypeFontRenderer methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 9/1/2012 21:30'!
advance: aPoint 
	advance := aPoint! !

!CairoFreetypeFontRenderer methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 9/2/2012 00:24'!
canvas: aCairoCanvas
	
	canvas := aCairoCanvas.! !

!CairoFreetypeFontRenderer methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 9/2/2012 00:28'!
font: aFreetypeFont 

	font := cache at: aFreetypeFont ifAbsentPut: [
		| ftFace face |
		
		ftFace := aFreetypeFont face.
		face := cache at: ftFace ifAbsentPut: [
			CairoFontFace fromFreetypeFace: ftFace
			]. 
	
		CairoScaledFont fromFreetypeFont: aFreetypeFont cairoFace: face.
	].

	originalFont := aFreetypeFont.
! !

!CairoFreetypeFontRenderer methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 9/2/2012 00:24'!
initialize 
	utfConverter := CairoUTF8Converter new.
	advance := 0@0.
	cache := CairoBackendCache soleInstance.! !

!CairoFreetypeFontRenderer methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 8/30/2012 18:27'!
render: aString

	^ self renderCharacters: aString from: 1 to: aString size! !

!CairoFreetypeFontRenderer methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 10/11/2012 15:46'!
renderCharacters: aString from: start to: end

	| utfString extents currentPt |

	utfConverter convert: aString from: start to: end.

	font lock.
	
	canvas
		setScaledFont: font;
		setFontSize: originalFont pixelSize.
		
	canvas 
		setPathMatrix;
		newPath;
		moveToX: advance x Y: advance y.

	canvas paint loadOn: canvas.

	currentPt := canvas getCurrentPoint.
	
	canvas	showText: utfConverter buffer.
	font unlock.		
	
	^ canvas getCurrentPoint - currentPt.

	"cairo_show_text ()"
	
! !

!CairoFreetypeFontRenderer methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 9/2/2012 01:43'!
setColor: aColor 
	(canvas setPaint: aColor )! !

Object subclass: #CairoLibraryLoader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Cairo'!

CairoLibraryLoader class
	instanceVariableNames: 'session libHandle'!

!CairoLibraryLoader commentStamp: '<historical>' prior: 0!
i am a service class, which responsible to finding and loading cairo dynamic library!

CairoLibraryLoader class
	instanceVariableNames: 'session libHandle'!

!CairoLibraryLoader class methodsFor: 'linux' stamp: 'IgorStasenko 4/16/2013 15:56'!
cantFindCairoOnLinux
	"
	Cog VM is a 32-bit process, and therefore won't link with 64-bit libraries on 64-bit OS.
	In case if you have problems with cairo library on linux system, try following:
	
	Installing 32-bit version of Cairo library.
	
	for Fedora it is:
		$ yum install cairo.i686
		/usr/lib/libcairo.so.2
	for Ubuntu:
		$ sudo apt-get install libcairo2:i386
		/usr/lib/i386-linux-gnu/libcairo.so.2

	If library is installed try to locate it and add path to it to #pathToCairoOnLinux method.
	
	"
	
	self error: 'Cannot locate cairo library. Please check if it installed on your system'! !

!CairoLibraryLoader class methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 6/10/2012 05:46'!
getLibraryHandle

	(NativeBoost sessionChanged: session) ifTrue: [
		libHandle := self loadCairoLibrary.
		session := NativeBoost uniqueSessionObject.
	].

	^ libHandle
	! !

!CairoLibraryLoader class methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 4/16/2013 15:50'!
getLibraryPath

	(NativeBoost platformId = NativeBoostConstants linux32PlatformId) ifTrue: [
		^ self pathToCairoOnLinux.
	].
	(NativeBoost platformId = NativeBoostConstants mac32PlatformId) ifTrue: [
		^ 'libcairo.2.dylib'
	].
	(NativeBoost platformId = NativeBoostConstants win32PlatformId) ifTrue: [
		^ 'libcairo-2.dll'
	].
	self error: 'define your own path'

! !

!CairoLibraryLoader class methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 6/10/2012 05:42'!
loadCairoLibrary 
	^ NativeBoost forCurrentPlatform loadModule: self getLibraryPath
! !

!CairoLibraryLoader class methodsFor: 'linux' stamp: 'IgorStasenko 7/29/2013 10:41'!
pathToCairoOnLinux
	"On different flavors of linux the path to library may differ
	depending on OS distro or whether system is 32 or 64 bit.
	
	"
	#( 
		'/usr/lib/i386-linux-gnu/libcairo.so.2'
		'/usr/lib32/libcairo.so.2'
		'/usr/lib/libcairo.so.2'
		
	) do: [ :path |
		
		path asFileReference exists ifTrue: [  ^ path ]
	].

	^ self cantFindCairoOnLinux

	! !

Object subclass: #CairoUTF8Converter
	instanceVariableNames: 'buffer len asm'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Cairo-Text'!

!CairoUTF8Converter commentStamp: '<historical>' prior: 0!
i use persistent buffer to convert strings to utf-8 strings (an input neede by cairo)!

!CairoUTF8Converter methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 8/28/2012 18:03'!
buffer
	^ buffer! !

!CairoUTF8Converter methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 8/28/2012 14:10'!
checkBufferSpace: minimalSize
	| size |
	
	size := buffer ifNil: [ 0 ] ifNotNil: [ buffer size ].
	
	size < minimalSize ifTrue: [
		buffer := ByteArray new: minimalSize.
		]
! !

!CairoUTF8Converter methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 8/28/2012 18:31'!
convert: aString from: start to: end
	| bs stream |
	self checkBufferSpace: 4*(end-start + 2).
	
	stream := ZnCharacterWriteStream on: (bs :=buffer writeStream).
	
	stream next: end-start+1 putAll: aString startingAt: start.
"	start to: end do: [:i| 	stream nextPut: (aString at: i) ].
"	bs nextPut: 0.
	^ bs position.! !

!CairoUTF8Converter methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 6/12/2012 18:07'!
convertByteString: aByteString 

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	^ NBFFICallout cdecl: #( void (void * aByteString)) emitCall: [:gen :proxy :asm |
		
		
		
		
		
	]! !

!CairoUTF8Converter methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 6/22/2012 02:56'!
convertUnicode: asm
"
input:
- EAX  32-bit unicode value to convert
.
output:
- EAX - utf-8 encoded character (in little-endian byte order) max 4 bytes
- EDX - number of encoded bytes
"
	| moreThanOne moreThanTwo moreThanThree end |
	
	moreThanOne := asm uniqueLabelName: 'moreThanOne'.
	moreThanTwo := asm uniqueLabelName: 'moreThanTwo'.
	moreThanThree := asm uniqueLabelName: 'moreThanThree'.
	end := asm uniqueLabelName: 'end'.
	
	asm
		cmp:  asm EAX with: 16r7F;
		jg: moreThanOne;
	"one byte"
		mov: 1 to: asm EDX;
		jmp: end;
	label: moreThanOne;
		cmp: asm EAX with: 16r7FF;
	 	jg: moreThanTwo;
"two bytes 80 .. 7FF"
" 	AH 			AL 	      "
"00000aaa aabbbbbb"
	
"110aaaaa 10bbbbbb
	AL                      AH   (little endian order)
"
		shr: asm EAX with: 2;
		shl: asm AL with: 2;
		or: asm AX with: 2r1100000010000000;
		xchg: asm AL with: asm AH;
		mov: 2 to: asm EDX; 
		jmp: end;
	label: moreThanTwo;
		cmp: asm EAX with: 16rFFFF;
	 	jg: moreThanThree;
"three bytes 800 ... FFFF"	
" 	AH 			AL 	      "
"aaaabbbb bbcccccc"
" => 1110aaaa 10bbbbbb 10cccccc"
		shl: asm EAX with: 4;
		shr: asm AX with: 2;
		shr: asm AL with: 2;
	" EAX = ...aaaa xxbbbbbb xxcccccc "
		or: asm EAX with: 2r111000001000000010000000;  "16rE08080"	
		shl: asm EAX with: 8;
		bswap: asm EAX;
		mov: 3 to: asm EDX;
		jmp: end;
"four bytes 1000 ... 10FFFF"	
" 	AH 			AL 	      "
"000aaabb bbbbcccc ccdddddd"
"=> 11110aaa 10bbbbbb 10cccccc 10dddddd"		
		mov: asm EAX to: asm EDX;
		shl: asm EAX with: 4;
		shr: asm AX with: 2;
		shr: asm AL with: 2;
	" EAX = 0000000a aabbbbbb xxcccccc xxdddddd "
		and: asm EAX with: 16r3F3F3F;
		bswap: asm EAX;
		shr: asm EDX with: 18; "6*3"
		or: asm DL with: 16r11110000;
		mov: asm DL to: asm AL;
		mov: 4 to: asm EDX;
	label: end
! !

!CairoUTF8Converter methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 6/22/2012 14:28'!
convertUnicode: asm conversionLabels: convLabels
"
input:
- EAX  32-bit unicode value to convert
.
output:
- EAX - utf-8 encoded character (in little-endian byte order) max 4 bytes
- EDX - number of encoded bytes
"
	|  moreThanTwo moreThanThree |
	
	moreThanTwo := asm uniqueLabelName: 'moreThanTwo'.
	moreThanThree := asm uniqueLabelName: 'moreThanThree'.
	
	asm
		cmp:  asm EAX with: 16r7F;
		jle: (convLabels at: 1); "one byte"

		cmp: asm EAX with: 16r7FF;
	 	jg: moreThanTwo;
"two bytes 80 .. 7FF"
" 	AH 			AL 	      "
"00000aaa aabbbbbb"
	
"110aaaaa 10bbbbbb
	AL                      AH   (little endian order)
"
		shr: asm EAX with: 2;
		shl: asm AL with: 2;
		or: asm AX with: 2r1100000010000000;
		xchg: asm AL with: asm AH;
		jmp: (convLabels at: 2);
	label: moreThanTwo;
		cmp: asm EAX with: 16rFFFF;
	 	jg: moreThanThree;
"three bytes 800 ... FFFF"	
" 	AH 			AL 	      "
"aaaabbbb bbcccccc"
" => 1110aaaa 10bbbbbb 10cccccc"
		shl: asm EAX with: 4;
		shr: asm AX with: 2;
		shr: asm AL with: 2;
	" EAX = ...aaaa xxbbbbbb xxcccccc "
		or: asm EAX with: 2r111000001000000010000000;  "16rE08080"	
		shl: asm EAX with: 8;
		bswap: asm EAX;
		jmp: (convLabels at: 3);
"four bytes 1000 ... 10FFFF"	
" 	AH 			AL 	      "
"000aaabb bbbbcccc ccdddddd"
"=> 11110aaa 10bbbbbb 10cccccc 10dddddd"		
		mov: asm EAX to: asm EDX;
		shl: asm EAX with: 4;
		shr: asm AX with: 2;
		shr: asm AL with: 2;
	" EAX = 0000000a aabbbbbb xxcccccc xxdddddd "
		and: asm EAX with: 16r3F3F3F;
		or: asm EAX with: 16r808080;
		bswap: asm EAX;
		shr: asm EDX with: 18; "6*3"
		or: asm DL with: 16r11110000;
		mov: asm DL to: asm AL;
		jmp: (convLabels at: 4)! !

!CairoUTF8Converter methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 6/12/2012 18:02'!
convertWideString: aWideString ! !

!CairoUTF8Converter methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 6/22/2012 15:10'!
store: numBytes accumulated: accumBytes

	| toShift left |
	
	asm label: ('write', numBytes asString , 'to' , accumBytes asString) asSymbol.
	
	(accumBytes + numBytes ) > 4 
		ifTrue: [ toShift := 4 - accumBytes. left := numBytes - toShift ] 
		ifFalse: [ toShift := numBytes. left := 0 ].
	
	(accumBytes = 0 and: [numBytes = 4]) ifTrue: [
		"just store directly"
		asm mov: asm EAX to: asm EDI ptr.	
	].
	asm shrd: asm EBX with: asm EAX with: toShift * 8.
	
! !
CairoBackendCache initialize!
